<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * BABE_Calendar_functions Class.
 * 
 * @class 		BABE_Calendar_functions
 * @version		1.0.0
 * @author 		Booking Algorithms
 */

class BABE_Calendar_functions {

    // sunday number
    static $week_sunday = 0;
    
    // first day number on the calendar week line
    static $week_first_day = 0;
    
    // last day number on the calendar week line
    static $week_last_day = 6;
    
    // date format for admin js calendars
    static $date_format = 'd/m/Y';
    
    // DB tables
    static $table_av_cal;
    
    // months names
    static $months_names = array();
    
///////////////////////////////////////    
    /**
	 * Setup vars based on start of week 
	 */
    public static function init() {
        global $wpdb;
        self::$table_av_cal = $wpdb->prefix.'babe_av_cal';
        
        if(get_option('start_of_week') != 0){
           self::$week_first_day = 1;
           self::$week_sunday = 7;
           self::$week_last_day = 7;
        }
        
        self::$months_names = self::get_months_arr();       
	}
///////////////////////////////////////
///////////////////////////////////////
    /**
	 * Get months locale names.
     * @return array
	 */
    public static function get_months_arr(){ 
    
    return array(
      'January' => __('January', BABE_TEXTDOMAIN ),
      'February' => __('February', BABE_TEXTDOMAIN ),
      'March' => __('March', BABE_TEXTDOMAIN ),
      'April' => __('April', BABE_TEXTDOMAIN ),
      'May' => __('May', BABE_TEXTDOMAIN ),
      'June' => __('June', BABE_TEXTDOMAIN ),
      'July' => __('July', BABE_TEXTDOMAIN ),
      'August' => __('August', BABE_TEXTDOMAIN ),
      'September' => __('September', BABE_TEXTDOMAIN ),
      'October' => __('October', BABE_TEXTDOMAIN ),
      'November' => __('November', BABE_TEXTDOMAIN ),
      'December' => __('December', BABE_TEXTDOMAIN ),  
     );
          
    }
    
///////////////////////////////////////
    /**
	 * Get months locale names.
     * @return array
	 */
    public static function get_months_arr_short(){ 
    
    return array(
      'Jan' => __('Jan', BABE_TEXTDOMAIN ),
      'Feb' => __('Feb', BABE_TEXTDOMAIN ),
      'Mar' => __('Mar', BABE_TEXTDOMAIN ),
      'Apr' => __('Apr', BABE_TEXTDOMAIN ),
      'May' => __('May', BABE_TEXTDOMAIN ),
      'Jun' => __('Jun', BABE_TEXTDOMAIN ),
      'Jul' => __('Jul', BABE_TEXTDOMAIN ),
      'Aug' => __('Aug', BABE_TEXTDOMAIN ),
      'Sep' => __('Sep', BABE_TEXTDOMAIN ),
      'Oct' => __('Oct', BABE_TEXTDOMAIN ),
      'Nov' => __('Nov', BABE_TEXTDOMAIN ),
      'Dec' => __('Dec', BABE_TEXTDOMAIN ),  
     );
          
    }
    
///////////////////////////////////////
    /**
	 * Get week days ODBC indexes (for MySQL DAYOFWEEK()) from PHP indexes.
     * 
     * @return array
	 */
    public static function week_days_to_odbc_arr(){ 
    
    return !self::$week_sunday ? array(
      0 => 1,
      1 => 2,
      2 => 3,
      3 => 4,
      4 => 5,
      5 => 6,
      6 => 7,   
     ) : array(
      1 => 2,
      2 => 3,
      3 => 4,
      4 => 5,
      5 => 6,
      6 => 7,
      7 => 1,   
     );     
    }        
    
///////////////////////////////////////
    /**
	 * Get week days short names.
     * @return array
	 */
    public static function get_week_days_arr(){ 
    
    return !self::$week_sunday ? array(
      0 => __('Sun', BABE_TEXTDOMAIN ),
      1 => __('Mon', BABE_TEXTDOMAIN ),
      2 => __('Tue', BABE_TEXTDOMAIN ),
      3 => __('Wed', BABE_TEXTDOMAIN ),
      4 => __('Thu', BABE_TEXTDOMAIN ),
      5 => __('Fri', BABE_TEXTDOMAIN ),
      6 => __('Sat', BABE_TEXTDOMAIN ),   
     ) : array(
      1 => __('Mon', BABE_TEXTDOMAIN ),
      2 => __('Tue', BABE_TEXTDOMAIN ),
      3 => __('Wed', BABE_TEXTDOMAIN ),
      4 => __('Thu', BABE_TEXTDOMAIN ),
      5 => __('Fri', BABE_TEXTDOMAIN ),
      6 => __('Sat', BABE_TEXTDOMAIN ),
      7 => __('Sun', BABE_TEXTDOMAIN ),   
     );     
    }
    
///////////////////////////////////////
    /**
	 * Get week days short names.
     * @return array
	 */
    public static function get_week_days_arr_2(){ 
    
    return !self::$week_sunday ? array(
      0 => __('Su', BABE_TEXTDOMAIN ),
      1 => __('Mo', BABE_TEXTDOMAIN ),
      2 => __('Tu', BABE_TEXTDOMAIN ),
      3 => __('We', BABE_TEXTDOMAIN ),
      4 => __('Th', BABE_TEXTDOMAIN ),
      5 => __('Fr', BABE_TEXTDOMAIN ),
      6 => __('Sa', BABE_TEXTDOMAIN ),   
     ) : array(
      1 => __('Mo', BABE_TEXTDOMAIN ),
      2 => __('Tu', BABE_TEXTDOMAIN ),
      3 => __('We', BABE_TEXTDOMAIN ),
      4 => __('Th', BABE_TEXTDOMAIN ),
      5 => __('Fr', BABE_TEXTDOMAIN ),
      6 => __('Sa', BABE_TEXTDOMAIN ),
      7 => __('Su', BABE_TEXTDOMAIN ),   
     );     
    }    

///////////////////////////////////////
    /**
	 * Get week day short name by its number.
     * @param int $i - week day number.
     * @return array
	 */
    public static function get_week_day($i){
      $arr = self::get_week_days_arr();
      if ($i > 7 || $i < 0) $i = 1;
      $i = $i%7;
      if (self::$week_sunday && $i==0){
            $i = 7; 
      }
       
      return $arr[$i];
    }

///////////////////////////////////////
    /**
	 * Get week days short names list.
     * @return array
	 */
    public static function cmb2_get_week_options(){
        return self::get_week_days_arr();    
    }

///////////////////////////////////////
    /**
	 * Get week day number.
     * 
     * @param Date Object $date_obj (PHP).
     * 
     * @return int
	 */
    public static function get_week_day_num($date_obj){
        $day_num = !self::$week_sunday ? $date_obj->format("w") : $date_obj->format("N");
        return $day_num;
    }

///////////////////////////////////////
    /**
	 * Get next week day number.
     * @param int - current day number.
     * @return int
	 */
    public static function get_next_week_day_num($w){
        $w = ($w+1)%7;
        if (self::$week_sunday && $w==0){
            $w = 7; 
        }
        return $w;
    }

///////////////////////////////////////
    /**
	 * Is the day number - last day number on the calendar week line?
     * @param int - day number.
     * @return boolean
	 */
    public static function is_week_day_weekend($w){
        return (self::$week_last_day == $w) ? true : false; 
    }
///////////////////////////////////////
    /**
	 * Is date is valid date
     * @param string $date.
     * @param string $format - PHP date format
     * @return boolean
	 */
    public static function isValidDate($date, $format = 'Y-m-d'){
        $d = DateTime::createFromFormat($format, $date);
        return $d && $d->format($format) == $date; 
    }

///////////////////////
     /**
	 * Is time is valid time
     * @param string $time
     * @param string $format - PHP time format
     * @return boolean
	 */
    public static function isValidTime($time, $format = ''){
        $format = $format ? 'Y-m-d '.$format : 'Y-m-d '.get_option('time_format');
        $date = '2017-01-01 '.$time;
        $d = DateTime::createFromFormat($format, $date);
        return $d && $d->format($format) == $date; 
    }
    
////////////////////////
     /**
	 * Convert d/m/Y or m/d/Y to SQL format
     * @param string $date
     * @return string
	 */
     public static function date_to_sql($date){    
        $d = DateTime::createFromFormat(BABE_Settings::$settings['date_format'], $date);
        return $d ? $d->format('Y-m-d') : '';
     }
////////////////////////
     /**
	 * Convert SQL date format to d/m/Y or m/d/Y
     * @param string $date
     * @return string
	 */
     public static function date_from_sql($date){
        $d = DateTime::createFromFormat('Y-m-d', $date);
        return $d ? $d->format(BABE_Settings::$settings['date_format']) : '';
     }
        
////////////////////////
     /**
	 * Update availability calendar
     * 
     * @param int $booking_obj_id
     * @param string $date_from - d/m/Y or m/d/Y
     * @param string $date_to - d/m/Y or m/d/Y
     * @param array $schedule
     * 
     * @return
	 */
     public static function update_av_cal($booking_obj_id, $date_from, $date_to, $schedule = array()){
        
        global $wpdb;
        
        $date_start = self::date_to_sql($date_from);
        $date_end = self::date_to_sql($date_to);
        
        $where_clauses = '';
        
        if (empty($schedule)){
            $where_clauses = "AND ( date_from < '".$date_start." 00:00:00' OR date_from > '".$date_end." 23:59:59')";
        }
               
        /// get av_cal
        $av_cal = $wpdb->get_results("SELECT * FROM ".self::$table_av_cal." WHERE booking_obj_id = '".$booking_obj_id."' ".$where_clauses." ORDER BY date_from ASC", ARRAY_A);
        
        $av_cal_all = $wpdb->get_results("SELECT * FROM ".self::$table_av_cal." WHERE booking_obj_id = '".$booking_obj_id."' ORDER BY date_from ASC", ARRAY_A);
        
        if (!empty($av_cal)){
            foreach($av_cal as $item){
               $date_arr[$item['date_from']] = 0; 
            }
        } else {
            $date_arr = array();
        }
        
        if (!empty($av_cal_all)){
            foreach($av_cal_all as $item){ 
               $date_arr_all[$item['date_from']] = 0;                
            }
        } else {
            $date_arr_all = array();
        }
        
        $new_date_arr = array();
        
        $begin = new DateTime( $date_start );
        $end = new DateTime( $date_end );
        $end->modify( '+1 day' );
        $interval = new DateInterval('P1D');
        $daterange = new DatePeriod($begin, $interval, $end);
        foreach($daterange as $date){
            $day_num = self::get_week_day_num($date);
            if(!empty($schedule)){
                if(isset($schedule[$day_num])){
                foreach($schedule[$day_num] as $time){
                    $cur_date = new DateTime($date->format('Y-m-d').' '.$time);
                    if (isset($date_arr[$cur_date->format('Y-m-d H:i:s')])){
                        $date_arr[$cur_date->format('Y-m-d H:i:s')] = 1;
                    } else {
                        $new_date_arr[$cur_date->format('Y-m-d H:i:s')] = 1;
                    } 
                } //// end foreach $schedule[$day_num]
              } /// end if isset($schedule[$day_num])  
            } else {
                if (isset($date_arr_all[$date->format('Y-m-d H:i:s')])){
                        $date_arr_all[$date->format('Y-m-d H:i:s')] = 1;
                    } else {
                        $new_date_arr[$date->format('Y-m-d H:i:s')] = 1;
                    }
            }   
        }
        
        /// reset in_schedule to 0 where $date_arr = 0
        $reset_arr = array();
        foreach($date_arr as $date_sql => $val){
            if (!$val){
                $reset_arr[] = "'".$date_sql."'";
            }
        }
        
        $prepare_result = $wpdb->query( "UPDATE ".self::$table_av_cal." SET in_schedule = 1 WHERE booking_obj_id = ".$booking_obj_id." AND in_schedule = 2" );
        
        if (!empty($reset_arr)){
            
            $in_statement = implode(", ", $reset_arr);
            $result = $wpdb->query( "UPDATE ".self::$table_av_cal." SET in_schedule = 2 WHERE booking_obj_id = ".$booking_obj_id." AND date_from IN (".$in_statement.")" );
   
        }
   
        /// add dates from $new_date_arr to schedule
        self::add_dates_to_av_cal($booking_obj_id, $new_date_arr);
        
        /// clear av_cal
        $wpdb->query( $wpdb->prepare( 'DELETE FROM '.self::$table_av_cal.' WHERE booking_obj_id = %d AND in_schedule = 2 AND guests = 0', $booking_obj_id ) );
        
        self::update_av_cal_excluded_dates($booking_obj_id);
        
        return;
        
     }
     
////////////////////////
     /**
	 * Update availability calendar excluded dates
     * 
     * @param int $booking_obj_id
     * 
     * @return
	 */
     public static function update_av_cal_excluded_dates($booking_obj_id){
        
        global $wpdb;
        
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($booking_obj_id);
        $categories_week_arr = isset($rules_cat['category_meta']) && isset($rules_cat['category_meta']['categories_week']) ? (array)$rules_cat['category_meta']['categories_week'] : array();
        $categories_week = !empty($categories_week_arr) ? array_flip($categories_week_arr) : array();
        
        $week_days = self::get_week_days_arr();
        $odbc_days = self::week_days_to_odbc_arr();
        
        $exclude_daynums = array();
        
        foreach ($week_days as $day_num => $day_title){
            
            if (!isset($categories_week[$day_num])){
                $exclude_daynums[] = $odbc_days[$day_num];
            }
            
        }
        
        $excluded_dates_statement = "";
        
        if (!empty($exclude_daynums)){
            $excluded_dates_statement .= " OR DAYOFWEEK(date_from) IN (".implode(", ", $exclude_daynums).")";   
        }
        
        $excluded_dates_meta = (array)get_post_meta( $booking_obj_id, 'excluded_dates', 1 );        
        
        if (!empty($excluded_dates_meta)){
            
            foreach($excluded_dates_meta as $excluded_date){
                
                if (is_array($excluded_date) && isset($excluded_date['excluded_date']) && self::isValidDate($excluded_date['excluded_date'], BABE_Settings::$settings['date_format'])){
                    
                    $date_exc_obj = new DateTime(self::date_to_sql($excluded_date['excluded_date']));
                    
                    $excluded_dates_statement .= " OR date_from LIKE '".$date_exc_obj->format('Y-m-d')." %'";
                    
                }
                
            }
            
        }
        
        $prepare_result = $wpdb->query( "UPDATE ".self::$table_av_cal." SET in_schedule = 1 WHERE booking_obj_id = ".$booking_obj_id." AND in_schedule = 0" );
        
        if ($excluded_dates_statement){
            
            $excluded_dates_statement = substr($excluded_dates_statement, 3);
        
            $result = $wpdb->query( "UPDATE ".self::$table_av_cal." SET in_schedule = 0 WHERE booking_obj_id = ".$booking_obj_id." AND (".$excluded_dates_statement.")" );
        
        }
        
        return;
        
     }     
     
////////////////////////
     /**
	 * Add dates to availability calendar
     * 
     * @param int $booking_obj_id
     * @param array $new_date_arr
     * 
     * @return
	 */
     public static function add_dates_to_av_cal($booking_obj_id, $new_date_arr){
        
        global $wpdb;
        
        if (!empty($new_date_arr)){
            
            $sql = "INSERT INTO ".self::$table_av_cal." (booking_obj_id,date_from,guests,in_schedule) VALUES ";
            $start_loop = true;
            foreach($new_date_arr as $date_sql => $val){
                
               if (!$start_loop) {
                  $sql .= ", ";
               } else {
                  $start_loop = false;
               }
                
               $sql .= "(".$booking_obj_id.",'".$date_sql."',0,1)";
            }
            $sql .= " ON DUPLICATE KEY UPDATE guests=VALUES(guests),in_schedule=VALUES(in_schedule)";
            
            $new_result = $wpdb->query($sql); /// db optimized
        }
     
        return;
     }           

////////////////////////
     /**
	 * Get availability calendar
     * @param int $booking_obj_id
     * @param string $date_from - Y-m-d H:i:s, must be valid
     * @param string $date_to - Y-m-d H:i:s
     * @param array $order_item_args
     * @return array
	 */
     public static function get_av_cal($booking_obj_id, $date_from = '', $date_to = '', $order_item_args = array()){
        
        global $wpdb;
        
        $output = array();
        
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($booking_obj_id);
        
        $stop_booking_before = $rules_cat['rules']['stop_booking_before'] ? absint(get_post_meta( $booking_obj_id, 'stop_booking_before', true )) : 0;        
        
        // normalize dates
        
        $date_now_obj = BABE_Functions::datetime_local();
        
        $date_to = !$date_from ? date("Y-m-d", strtotime("+1 year")) : (!$date_to ? $date_from : $date_to);       
        $date_from = !$date_from ? $date_now_obj->format("Y-m-d") : $date_from;

        $date_from_obj = new DateTime($date_from);
        $date_to_obj = new DateTime($date_to);
        
        if($date_from_obj == $date_to_obj){
           $date_to_obj = new DateTime($date_from_obj->format('Y-m-d 23:59:59')); 
        }
        
        $today_obj = BABE_Functions::datetime_local();
        
        //// check stop booking before ... hours //////////
        
        if ($today_obj->format('Y-m-d') == $date_from_obj->format('Y-m-d')){
            if ($rules_cat['rules']['basic_booking_period'] == 'recurrent_custom'){
                $today_obj->modify( '+'.$stop_booking_before.' hours' );
                if ($today_obj >= $date_to_obj) {
                    return $output;
                } elseif ($today_obj >= $date_from_obj){
                    $date_from_obj = new DateTime($today_obj->format('Y-m-d H:i'));
                } 
            }
        }
        
        $item_max_guests = absint(get_post_meta( $booking_obj_id, 'guests', 1 ));
 
        $max_guests = $item_max_guests * BABE_Post_types::get_post_items_number($booking_obj_id);
        
        $max_guests_add = !empty($order_item_args) && isset($order_item_args['booking_obj_id']) && $booking_obj_id == $order_item_args['booking_obj_id'] ? array_sum($order_item_args['guests']) : 0;
        
        if ($max_guests_add){
            
            if ($rules_cat['rules']['basic_booking_period'] == 'night'){
            
             $date_tmp_from = new DateTime($order_item_args['date_from']);
             $date_tmp_to = new DateTime($order_item_args['date_to']);
            
             $date_test_from_obj = new DateTime($date_tmp_from->format('Y-m-d'));
             $date_test_to_obj = new DateTime($date_tmp_to->format('Y-m-d'));
             
           } else {
             $date_test_from_obj = new DateTime($order_item_args['date_from']);
             $date_test_to_obj = new DateTime($order_item_args['date_to']);
           }
            
            if ($date_from_obj >= $date_test_from_obj){
                $date_from_obj = new DateTime($date_test_from_obj->format('Y-m-d H:i'));
            }
         }        
        
        //////////////////
        
        $datetime_from = $date_from_obj->format('Y-m-d H:i:s');
        $datetime_to = $date_to_obj->format('Y-m-d H:i:s');
        
        //$guests_filter = $rules_cat['rules']['booking_mode'] == 'object' ? "guests = 0" : "guests < ".$max_guests;
        $guests_filter = "guests <= ".$max_guests;
        
        $query = "SELECT *, DATE_FORMAT(date_from, '%Y-%m-%d') AS cal_date, DATE_FORMAT(date_from, '%H:%i') AS cal_time, CAST(DATE_FORMAT(date_from, '%Y') AS UNSIGNED) AS cal_year, CAST(DATE_FORMAT(date_from, '%m') AS UNSIGNED) AS cal_month, CAST(DATE_FORMAT(date_from, '%d') AS UNSIGNED) AS cal_day, (".$max_guests." - guests) AS av_guests 
        FROM ".self::$table_av_cal."
        
        WHERE (
           booking_obj_id = ".$booking_obj_id."
          AND
           ".$guests_filter."
          AND
           in_schedule = 1
          AND date_from >= '".$datetime_from."'
          AND date_from <= '".$datetime_to."'
        )
        
        ORDER BY date_from ASC    
";
        /// get av_cal
        $av_cal = $wpdb->get_results($query, ARRAY_A);
        
        if (!empty($av_cal)){
        $before_date = '';
        
        foreach($av_cal as $cal_row){
          if ($before_date != $cal_row['cal_date']){
            $output[$cal_row['cal_date']]['date'] = $cal_row['cal_date'];
            $output[$cal_row['cal_date']]['year'] = $cal_row['cal_year'];
            $output[$cal_row['cal_date']]['month'] = $cal_row['cal_month'];
            $output[$cal_row['cal_date']]['day'] = $cal_row['cal_day'];
            $before_date = $cal_row['cal_date'];
         }
         
         $curren_date_obj = new DateTime($cal_row['date_from']);
         
         $cal_row_av_guests = absint($cal_row['av_guests']) >= $item_max_guests ? $item_max_guests : absint($cal_row['av_guests']);
         
         if ($max_guests_add && $curren_date_obj >= $date_test_from_obj && $curren_date_obj <= $date_test_to_obj){
            $test_av_guests = $cal_row_av_guests + $max_guests_add;
            
            if (($rules_cat['rules']['basic_booking_period'] == 'day' && $cal_row['cal_time'] == '00:00') || $rules_cat['rules']['basic_booking_period'] != 'day'){
                $output[$cal_row['cal_date']]['times'][$cal_row['cal_time']] = $rules_cat['rules']['booking_mode'] == 'object' && $test_av_guests < $item_max_guests ? 0: $test_av_guests;
            }
         } else {
            
            $output[$cal_row['cal_date']]['times'][$cal_row['cal_time']] = $rules_cat['rules']['booking_mode'] == 'object' && $cal_row_av_guests < $item_max_guests ? 0: $cal_row_av_guests;
            
         }         
         
        }
        }
        
        return $output;
        
     }
     
////////////////////////
     /**
	 * Check booking obj availability
     * @param int $booking_obj_id
     * @param string $date_from - Y-m-d H:i:s, must be valid
     * @param string $date_to - Y-m-d H:i:s
     * @param array $guests_arr
     * @param array $order_item_args
     * 
     * @return int
	 */
     public static function check_booking_obj_av($booking_obj_id, $date_from = '', $date_to = '', $guests_arr = array(), $order_item_args = array()){
        
        $output = 0;
        
        $guests = array_sum($guests_arr);
        
        if ($guests > 0){
            
            $av_guests = self::get_av_guests($booking_obj_id, $date_from, $date_to, $order_item_args);
            
            $output = $av_guests >= $guests ? $av_guests : 0;
            
        }
        
        return $output;
        
     }     
     
////////////////////////
     /**
	 * Get availability guests number
     * @param int $booking_obj_id
     * @param string $date_from - Y-m-d H:i:s, must be valid
     * @param string $date_to - Y-m-d H:i:s
     * @param array $order_item_args
     * 
     * @return int
	 */
     public static function get_av_guests($booking_obj_id, $date_from = '', $date_to = '', $order_item_args = array()){
        
        global $wpdb;
        
        $output = 0;
        
        $booking_obj_id = absint($booking_obj_id);
        
        $item_max_guests = absint(get_post_meta( $booking_obj_id, 'guests', 1 ));
 
        $max_guests = $item_max_guests * BABE_Post_types::get_post_items_number($booking_obj_id);
        
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($booking_obj_id);
        
        $stop_booking_before = $rules_cat['rules']['stop_booking_before'] ? absint(get_post_meta( $booking_obj_id, 'stop_booking_before', 1 )) : 0;
        
        // normalize dates
        
        $date_now_obj = BABE_Functions::datetime_local();
        
        $date_to = !$date_from ? date("Y-m-d", strtotime("+1 year")) : (!$date_to ? $date_from : $date_to);         
        $date_from = !$date_from ? $date_now_obj->format("Y-m-d") : $date_from;

        $date_from_obj = new DateTime($date_from);
        $date_to_obj = new DateTime($date_to);
        
        if ($rules_cat['rules']['basic_booking_period'] == 'single_custom'){
            
            $date_from_obj = new DateTime($date_from_obj->format('Y-m-d 00:00:00'));
            $date_to_obj = new DateTime($date_from_obj->format('Y-m-d 23:59:59'));
            
        }
        
        if($date_from_obj == $date_to_obj && ($rules_cat['rules']['basic_booking_period'] != 'recurrent_custom' || ($rules_cat['rules']['basic_booking_period'] == 'recurrent_custom' && $date_from_obj->format('Y-m-d H:i') == $date_from_obj->format('Y-m-d 00:00')))){
           $date_to_obj = new DateTime($date_from_obj->format('Y-m-d 23:59:59')); 
        }
        
        $today_obj = BABE_Functions::datetime_local();
        
        //// check stop booking before ... hours //////////
        
        if ($today_obj->format('Y-m-d') == $date_from_obj->format('Y-m-d')){
            if ($rules_cat['rules']['basic_booking_period'] == 'recurrent_custom'){
                $today_obj->modify( '+'.$stop_booking_before.' hours' );
                if ($today_obj >= $date_to_obj) {
                    return 0;
                } elseif ($today_obj >= $date_from_obj){
                    $date_from_obj = new DateTime($today_obj->format('Y-m-d H:i'));
                }  
            }
        }
        
        $max_guests_add = !empty($order_item_args) && isset($order_item_args['booking_obj_id']) && $booking_obj_id == $order_item_args['booking_obj_id'] ? array_sum($order_item_args['guests']) : 0;
        
        if ($max_guests_add){
            
           if ($rules_cat['rules']['basic_booking_period'] == 'night'){
            
             $date_tmp_from = new DateTime($order_item_args['date_from']);
             $date_tmp_to = new DateTime($order_item_args['date_to']);
            
             $date_test_from_obj = new DateTime($date_tmp_from->format('Y-m-d'));
             $date_test_to_obj = new DateTime($date_tmp_to->format('Y-m-d'));
             
           } else {
             $date_test_from_obj = new DateTime($order_item_args['date_from']);
             $date_test_to_obj = new DateTime($order_item_args['date_to']);
           }
           
         }
        
        /////////hold support///////
        
        if ($rules_cat['rules']['basic_booking_period'] == 'day' && $rules_cat['rules']['hold']){
            $date_from_obj->modify('-'.$rules_cat['rules']['hold'].' hours');
            $date_from_obj->modify('+2 minutes');
            $date_to_obj->modify('+'.$rules_cat['rules']['hold'].' hours');
            $date_to_obj->modify('-2 minutes');
        }
        
        $datetime_from = $date_from_obj->format('Y-m-d H:i:s');
        $datetime_to = $date_to_obj->format('Y-m-d H:i:s');
        
        $query = "SELECT *, DATE_FORMAT(date_from, '%H:%i') AS cal_time, (".$max_guests." - guests) AS av_guests
        FROM ".self::$table_av_cal."
        
        WHERE (
           booking_obj_id = ".$booking_obj_id."
          AND
           in_schedule = 1
          AND date_from >= '".$datetime_from."'
          AND date_from ".($rules_cat['rules']['basic_booking_period'] == 'night' ? "<" : "<=")." '".$datetime_to."'
        )
        
        ORDER BY date_from ASC    
";
        /// get av_cal
        
        $av_cal = $wpdb->get_results($query, ARRAY_A);
        
        $av_guests_arr = array();
        
        if (!empty($av_cal)){
        
        foreach($av_cal as $cal_row){
         
         $curren_date_obj = new DateTime($cal_row['date_from']);
         
         $cal_row_av_guests = absint($cal_row['av_guests']) >= $item_max_guests ? $item_max_guests : absint($cal_row['av_guests']);
         
         if ($max_guests_add && $curren_date_obj >= $date_test_from_obj && $curren_date_obj <= $date_test_to_obj){
            $test_av_guests = $cal_row_av_guests + $max_guests_add;
            
            if (($rules_cat['rules']['basic_booking_period'] == 'day' && $cal_row['cal_time'] == '00:00') || $rules_cat['rules']['basic_booking_period'] != 'day'){
                $av_guests_arr[] = $rules_cat['rules']['booking_mode'] == 'object' && $test_av_guests < $item_max_guests ? 0 : $test_av_guests;
                
            }
            
         } else {
            
            $av_guests_arr[] = $rules_cat['rules']['booking_mode'] == 'object' && $cal_row_av_guests < $item_max_guests ? 0 : $cal_row_av_guests;
            
         }         
         
        }
        
        //error_log('$av_cal: '.print_r($av_cal, 1));
        
        //error_log('$av_guests_arr: '.print_r($av_guests_arr, 1));
        
        $output = $rules_cat['rules']['basic_booking_period'] == 'recurrent_custom' ? max($av_guests_arr) : min($av_guests_arr);
        
        }
        
       // $output = !empty($av_cal) && $av_cal[0]['av_guests'] > 0 && ($rules_cat['rules']['booking_mode'] != 'object' || ($rules_cat['rules']['booking_mode'] == 'object' && $av_cal[0]['av_guests'] == $max_guests)) ? $av_cal[0]['av_guests'] : 0;
        
        return $output;
        
     }
     
////////////////////////
     /**
	 * Update (add or substract) guests number
     * @param int $booking_obj_id
     * @param string $date_from - Y-m-d H:i:s, must be valid
     * @param string $date_to - Y-m-d H:i:s
     * @param int $guests - positive or negative
     * @return boolean
	 */
     public static function update_av_guests($booking_obj_id, $date_from, $date_to, $new_guests){
        
        global $wpdb;
        
        $output = 0;
        $booking_obj_id = absint($booking_obj_id);
        
        $new_guests = intval($new_guests);
        $item_max_guests = absint(get_post_meta( $booking_obj_id, 'guests', 1 ));
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($booking_obj_id);
        
        if ($rules_cat['rules']['booking_mode'] == 'object'){
            $sign = $new_guests > 0 ? 1 : -1;
            $new_guests = $item_max_guests*$sign;
        }

        $date_from_obj = new DateTime($date_from);
        $date_to_obj = new DateTime($date_to);
        
        if ($rules_cat['rules']['basic_booking_period'] == 'single_custom'){
            
            $date_from_obj = new DateTime($date_from_obj->format('Y-m-d 00:00:00'));
            $date_to_obj = new DateTime($date_from_obj->format('Y-m-d 23:59:59'));
            
        }
        
        $datetime_from = $rules_cat['rules']['basic_booking_period'] != 'night' ? $date_from_obj->format('Y-m-d H:i:s') : $date_from_obj->format('Y-m-d 00:00:00');
        $datetime_to = $rules_cat['rules']['basic_booking_period'] != 'night' ? $date_to_obj->format('Y-m-d H:i:s') : $date_to_obj->format('Y-m-d 00:00:00');
        
        if ($new_guests && $rules_cat['rules']['basic_booking_period'] == 'day' && ($date_from_obj->format('H:i:s') != '00:00:00' || $date_to_obj->format('H:i:s') != '00:00:00')){
            //// maybe add $datetime_from and $datetime_to to $table_av_cal
            $av_cal = $wpdb->get_results("SELECT * FROM ".self::$table_av_cal." WHERE booking_obj_id = '".$booking_obj_id."' AND in_schedule = '1' AND date_from >= '".$datetime_from."' AND date_from <= '".$datetime_to."' ORDER BY date_from ASC", ARRAY_A);
            $new_date_arr = array();
            $date_arr = array();
            if (!empty($av_cal)){
                foreach($av_cal as $item){
                   $date_arr[$item['date_from']] = 0; 
                }
            }
            
            if (!isset($date_arr[$datetime_from])){
                $new_date_arr[$datetime_from] = 1;
            }
            if (!isset($date_arr[$datetime_to])){
                $new_date_arr[$datetime_to] = 1;
            }
            self::add_dates_to_av_cal($booking_obj_id, $new_date_arr);
        }
        
        if ($new_guests < 0 && $rules_cat['rules']['basic_booking_period'] == 'day'){
            //// clear db from none 00:00:00 time lines
            $where_clauses_arr = array();
            
            if ($date_from_obj->format('H:i:s') != '00:00:00'){
                $where_clauses_arr[] = "date_from = '".$datetime_from."'";
            }
            if ($date_to_obj->format('H:i:s') != '00:00:00'){
                $where_clauses_arr[] = "date_from = '".$datetime_to."'";
            }
            
            if (!empty($where_clauses_arr)){
                
                $where_clauses = "AND (".implode(' OR ',$where_clauses_arr).")";
                $wpdb->query( $wpdb->prepare( 'DELETE FROM '.self::$table_av_cal.' WHERE booking_obj_id = %d '.$where_clauses, $booking_obj_id ) );
                
            }
            
        }
        
        $query = "UPDATE ".self::$table_av_cal." SET guests = guests + ".$new_guests."
        
        WHERE (
           booking_obj_id = ".$booking_obj_id."
          AND
           in_schedule = 1
          AND date_from >= '".$datetime_from."'
          AND date_from ".($rules_cat['rules']['basic_booking_period'] == 'night' ? "<" : "<=")." '".$datetime_to."'
        )    
";
        /// update guests
        $output = $wpdb->query($query, ARRAY_A);
        
        return $output;
        
     }           

/////////////////////////////    
    
}

BABE_Calendar_functions::init();
