<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * BABE_html Class.
 * 
 * @class 		BABE_html
 * @version		1.2.7
 * @author 		Booking Algorithms
 */

class BABE_html {
    
    // variables to use
    private static $nonce_title = 'babe-nonce';
    
    //// cache
    
    private static $order_items = array();
    
    private static $order_customer_details = array();
    
//////////////////////////////
    /**
	 * Hook in tabs.
	 */
    public static function init() {
        
        add_filter( 'the_content', array( __CLASS__, 'post_content'), 10, 1 );
        add_filter( 'the_content', array( __CLASS__, 'pages_content'), 10, 1 );
        add_filter( 'the_content', array( __CLASS__, 'page_search_result'), 10, 1 );
        
        add_action( 'init', array(__CLASS__, 'action_init'), 10);
        
        add_filter( 'babe_search_result_description', array( __CLASS__, 'search_result_description_price'), 10, 2);
        
        add_filter( 'babe_post_content', array( __CLASS__, 'babe_post_content'), 10, 3);
        
        add_filter('babe_checkout_field_required', array( __CLASS__, 'checkout_field_required'), 10, 2);
        
        add_action( 'wp_enqueue_scripts', array( __CLASS__, 'enqueued_assets' ) );
        
        add_filter( 'script_loader_tag', array( __CLASS__, 'async_defer_scripts'), 20, 3);
        
        add_action( 'wp_ajax_get_meeting_points', array( __CLASS__, 'ajax_get_meeting_points'));
        add_action( 'wp_ajax_nopriv_get_meeting_points', array( __CLASS__, 'ajax_get_meeting_points'));
        
        add_action( 'wp_ajax_get_times_guests', array( __CLASS__, 'ajax_get_times_guests'));
        add_action( 'wp_ajax_nopriv_get_times_guests', array( __CLASS__, 'ajax_get_times_guests'));
        //
        add_action( 'wp_ajax_get_booking_times', array( __CLASS__, 'ajax_get_booking_times'));
        add_action( 'wp_ajax_nopriv_get_booking_times', array( __CLASS__, 'ajax_get_booking_times'));
        
        add_action( 'wp_ajax_booking_calculate', array( __CLASS__, 'ajax_booking_calculate'));
        add_action( 'wp_ajax_nopriv_booking_calculate', array( __CLASS__, 'ajax_booking_calculate'));
        
        // apply coupon to order
        add_action( 'wp_ajax_apply_coupon_to_order', array( __CLASS__, 'ajax_apply_coupon_to_order'));
        add_action( 'wp_ajax_nopriv_apply_coupon_to_order', array( __CLASS__, 'ajax_apply_coupon_to_order'));
        
        // add coupon field
        add_filter('babe_chekout_after_order_items', array( __CLASS__, 'coupon_field_to_checkout_form' ), 10, 2);
        add_filter('babe_order_items_html', array( __CLASS__, 'coupon_field_to_order_items' ), 10, 4);
           
	}  
    
//////////////////////////////
    /**
	 * Hook in init
	 */
    public static function action_init() {
       
       if (function_exists('qtranxf_useCurrentLanguageIfNotFoundShowAvailable')){
          // qTranslate-x priority fix
          remove_filter('the_content', 'qtranxf_useCurrentLanguageIfNotFoundShowAvailable', 100);
          add_filter('the_content', 'qtranxf_useCurrentLanguageIfNotFoundShowAvailable', 0);
        }
    
       return;
    
    }        
    
//////////////////////////////
    /**
	 * Enqueue assets.
	 */
    public static function enqueued_assets() {
        
     global $post;
        
        wp_enqueue_script( 'babe-select2-js', plugins_url( "js/select2.full.min.js", BABE_PLUGIN ), array('jquery'), '1.0', true );
        
        ////////validation js////////
        wp_enqueue_script( 'babe-validate-js', plugins_url( "js/jquery.validate.min.js", BABE_PLUGIN ), array('babe-google-api'), '1.0', true );
        
        wp_enqueue_script( 'babe-util-js', plugins_url( "js/util.js", BABE_PLUGIN ), array('jquery'), '1.0', true );
        wp_enqueue_script( 'babe-modal-js', plugins_url( "js/babe-modal.js", BABE_PLUGIN ), array('jquery'), '1.0', true );
        wp_enqueue_script( 'babe-modal-adv-js', plugins_url( "js/modal.js", BABE_PLUGIN ), array('jquery'), '1.0', true );
        
     if ( BABE_DEV ){
        
        wp_enqueue_script( 'babe-js', plugins_url( "js/babe-scripts.js", BABE_PLUGIN ), array('babe-google-api'), '1.0', true );
        
     } else {
        
        wp_enqueue_script( 'babe-js', plugins_url( "js/babe-scripts.min.js", BABE_PLUGIN ), array('babe-google-api'), '1.0', true );
        
     }
     
     
     wp_enqueue_style( 'babe-select2-style', plugins_url( "css/select2.min.css", BABE_PLUGIN )); 
     
     ///// add google API
     wp_enqueue_script( 'babe-google-api', "https://maps.googleapis.com/maps/api/js?key=".BABE_Settings::$google_api_key."&libraries=places", array('jquery'), '', true );   
     
     /////// i18n for validation ////////////
     if (function_exists( 'qtranxf_getLanguage' )){
        $lang = qtranxf_getLanguage();
    } else {
        $lang = substr( get_locale(), 0, 2 );
    }
    $local_validate_langs = array('ar' => 'ar', 'az' => 'az', 'bg' => 'bg', 'ca' => 'ca', 'cs' => 'cs', 'da' => 'da', 'de' => 'de', 'el' => 'el', 'es' => 'es', 'et' => 'et', 'eu' => 'eu', 'fa' => 'fa', 'fi' => 'fi', 'fr' => 'fr', 'ge' => 'ge', 'gl' => 'gl', 'he' => 'he', 'hr' => 'hr', 'hu' => 'hu', 'hy' => 'hy', 'id' => 'id', 'is' => 'is', 'it' => 'it', 'ja' => 'ja', 'ka' => 'ka', 'kk' => 'kk', 'ko' => 'ko', 'lt' => 'lt', 'lv' => 'lv', 'mk' => 'mk', 'my' => 'my', 'nl' => 'nl', 'no' => 'no', 'pl' => 'pl', 'ro' => 'ro', 'ru' => 'ru', 'sd' => 'sd', 'si' => 'si', 'sk' => 'sk', 'sl' => 'sl', 'sr' => 'sr', 'sv' => 'sv', 'th' => 'th', 'tj' => 'tj', 'tr' => 'tr', 'uk' => 'uk', 'ur' => 'ur', 'vi' => 'vi', 'zh' => 'zh');
     
     if( isset($local_validate_langs[$lang])){
     wp_enqueue_script( 'babe-validate-local-js', plugins_url( "js/localization/messages_".$lang.".min.js", BABE_PLUGIN ), array('jquery'), '1.0', true );
     }
     ///////////////
     
     wp_enqueue_style( 'babe-modal-style', plugins_url( "css/babe-modal.css", BABE_PLUGIN ));
     
     if (is_single() && $post->post_type == BABE_Post_types::$booking_obj_post_type){    
        
     /////////////unitegallery/////////////
     if (!BABE_Settings::$settings['unitegallery_remove']){
     wp_enqueue_style( 'babe-unitegallery-styles', plugins_url('js/unitegallery/css/unite-gallery.css', BABE_PLUGIN ));
     wp_enqueue_style( 'babe-unitegallery-default-styles', plugins_url('js/unitegallery/themes/default/ug-theme-default.css', BABE_PLUGIN ), array('babe-unitegallery-styles'));
  
     wp_enqueue_script( 'babe-unitegallery-js', plugins_url('js/unitegallery/js/unitegallery.js', BABE_PLUGIN ), array('jquery'), '1.0', true);
     
     $unitegallery_theme = BABE_Settings::$unitegallery['gallery_theme'];
     
     wp_enqueue_script( 'babe-unitegallery-'.$unitegallery_theme.'-js', plugins_url('js/unitegallery/themes/'.$unitegallery_theme.'/ug-theme-'.$unitegallery_theme.'.js', BABE_PLUGIN ), array('babe-unitegallery-js'), '1.0', true);
     }
     ///////////////////////////////////////
        
            $post_id = $post->ID;            
            $av_cal = BABE_Calendar_functions::get_av_cal($post_id);
            $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
            $basic_booking_period = isset($rules_cat['rules']['basic_booking_period']) ? $rules_cat['rules']['basic_booking_period'] : '';
            $cal_first_click = $basic_booking_period && $basic_booking_period != 'recurrent_custom' && $basic_booking_period != 'single_custom' ? true : false;
            $cal_first_click = apply_filters( 'babe_localize_script_calendar_clicks', $cal_first_click, $post_id, $rules_cat);
            
            $date_from = isset($_GET['date_from']) && BABE_Calendar_functions::isValidDate($_GET['date_from'], BABE_Settings::$settings['date_format']) ? $_GET['date_from'] : null;
            $date_to = isset($_GET['date_to']) && BABE_Calendar_functions::isValidDate($_GET['date_to'], BABE_Settings::$settings['date_format']) ? $_GET['date_to'] : null;
            $time_from = isset($_GET['time_from']) && BABE_Calendar_functions::isValidTime($_GET['time_from'], 'H:i') ? $_GET['time_from'] : null;
            $time_to = isset($_GET['time_to']) && BABE_Calendar_functions::isValidTime($_GET['time_to'], 'H:i') ? $_GET['time_to'] : null;
            
     } else {
        $av_cal = array();
        $cal_first_click = false;
        $basic_booking_period = '';
        $date_from = null;
        $date_to = null;
        $time_from = null;
        $time_to = null;
     }  ///// end if (is_single() && $post->post_type == BABE_Post_types::$booking_obj_post_type)
     
     $travel_mode_html = '
               <div id="travel_mode_panel_modal">
                <label for="travel_mode_modal">'.__('Mode of Travel: ', BABE_TEXTDOMAIN).'</label>
                <select id="travel_mode_modal" name="travel_mode_modal">
                <option value="WALKING">'.__('Walking', BABE_TEXTDOMAIN).'</option>
                <option value="DRIVING">'.__('Driving', BABE_TEXTDOMAIN).'</option>
                <option value="BICYCLING">'.__('Bicycling', BABE_TEXTDOMAIN).'</option>
                </select>
               </div>
               
                <input class="address-autocomplete" name="autocomplete" placeholder="'.__( 'Enter your address', BABE_TEXTDOMAIN ).'" type="text" />
                ';    
     
     ////// localize babe-js
     wp_localize_script( 'babe-js', 'babe_lst', array(
            'ajax_url' => admin_url( 'admin-ajax.php' ),
            'date_format' => BABE_Settings::$settings['date_format'] == 'd/m/Y' ? 'dd/mm/yy' : 'mm/dd/yy',
            'date_from' => $date_from,
            'date_to' => $date_to,
            'time_from' => $time_from,
            'time_to' => $time_to,
            'nonce' => wp_create_nonce(self::$nonce_title),
            'av_cal' => $av_cal,
            'basic_booking_period' => $basic_booking_period,
            'cal_first_click' => $cal_first_click,
            'start_lat' => BABE_Settings::$settings['google_map_start_lat'],
            'start_lng' => BABE_Settings::$settings['google_map_start_lng'],
            'start_zoom' => BABE_Settings::$settings['google_map_zoom'],
            'marker_icon' => plugins_url( BABE_Settings::$markers_urls[BABE_Settings::$settings['google_map_marker']], BABE_PLUGIN ),
            'travel_mode_html' => $travel_mode_html,
            'unitegallery_args' => BABE_Settings::$unitegallery,
         )
     );
     
     ///// load datepicker
     wp_enqueue_script('jquery-ui-datepicker');
     wp_enqueue_style('jquery-ui-style', plugins_url( "css/jquery-ui.min.css", BABE_PLUGIN ), '', '1.12.1', 'all');
     ///
     wp_enqueue_style('babe-fontawesome', plugins_url( "fonts/fontawesome-free/css/all.min.css", BABE_PLUGIN ));
      
      //// load plugin general styles
      
      if ( BABE_DEV ){
        wp_enqueue_style( 'babe-style', plugins_url( "css/babe-style.css", BABE_PLUGIN ));
      } else {
        wp_enqueue_style( 'babe-style', plugins_url( "css/babe-style.min.css", BABE_PLUGIN ));
      }
      
     }
     
//////////////////////////////////////////////
    
    /**
     * Loads scripts as async or defer to improve site perfomance.
     */
    public static function async_defer_scripts($tag, $handle, $src) {
   
         $scripts = array(
			'babe-js' => 1,
            'babe-modal-js' => 1,
         );
   
         if (isset($scripts[$handle])) {
            return str_replace(' src', ' async="async" src', $tag);
         }
     
         return $tag;
    } 
            
////////////////////////////
    /**
	 * Add content to booking_obj page.
     * @param string $content
     * @return string
	 */
    public static function post_content($content){
        global $post;
        $output = $content;

        if (is_single() && in_the_loop() && is_main_query()){
          if ($post->post_type == BABE_Post_types::$booking_obj_post_type){  
            
            $babe_post = BABE_Post_types::get_post($post->ID);
            if (!empty($babe_post)){
              remove_filter( 'the_content', array( __CLASS__, 'post_content'), 10, 1 );
              $output = apply_filters( 'babe_post_content', $content, $post->ID, $babe_post);
            }
          }
          
          if ($post->post_type == BABE_Post_types::$mpoints_post_type){            
            remove_filter( 'the_content', array( __CLASS__, 'post_content'), 10, 1 );
            $output = $content;
            
            $address_arr['address'] = get_post_meta($post->ID, 'address', 1);
            $address_arr['ID'] = $post->ID;
            
            $output .= self::block_address_map_with_direction($address_arr);
          }             
        }
        
        return $output; 
    }

////////////////////////////
    /**
	 * Add our template content to booking_obj page.
     * @param string $content
     * @param int $post_id
     * @param array $post
     * @return string
	 */
    public static function babe_post_content($content, $post_id, $post){
        
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
        
        $output = '';
        
        $slides = self::block_slider($post);
        $output .= $slides;
        
        $output .= isset($post['code']) && $post['code'] ? '<div class="item_code">'.__( 'Item Code:', BABE_TEXTDOMAIN ).' <strong><span itemprop="productID">'.$post['code'].'</span></strong></div>' : '';
        
        $output .= BABE_Rating::post_stars_rendering($post_id);
        
        ///////////////////////
        
        if ($rules_cat['rules']['basic_booking_period'] == 'single_custom'){
            
            $date_from_obj = new DateTime( BABE_Calendar_functions::date_to_sql($post['start_date']).' '.$post['start_time']);
            $date_to_obj = new DateTime( BABE_Calendar_functions::date_to_sql($post['end_date']).' '.$post['end_time']);
            
            $dates = $date_from_obj->format(get_option('date_format').' '.get_option('time_format')).' - ';
            
            if ( $date_from_obj->format('Y-m-d') != $date_to_obj->format('Y-m-d') ){
                $dates .= $date_to_obj->format(get_option('date_format')).' ';
            }
            
            $dates .= $date_to_obj->format( get_option('time_format') );
            
            $output .= '<div class="single_event_dates">'.__( 'When:', BABE_TEXTDOMAIN ).' <span class="single_event_dates_value">'.$dates.'</span></div>';
            
        }
        
        //////////////////////
        
        $output .= self::block_price_from($post);
        
        $output .= apply_filters( 'babe_post_content_after_price', '', $content, $post_id, $post);
         
        $output .= $content;
            
            // slider
            // short info
            // content
        if(!BABE_Settings::$settings['av_calendar_remove'] && $rules_cat['rules']['basic_booking_period'] != 'single_custom'){    
            $output .= '<h3 class="babe_post_content_title">'.__( 'Calendar & Prices', BABE_TEXTDOMAIN ).'</h3>'.self::block_calendar($post);
        }
        
        $output .= apply_filters( 'babe_post_content_after_calendar', '', $content, $post_id, $post);
        
        $block_steps = self::block_steps($post);
        $output .= $block_steps ? '<h3 class="babe_post_content_title">'.__( 'Details', BABE_TEXTDOMAIN ).'</h3>'.$block_steps : '';
        
        if(!BABE_Settings::$settings['google_map_remove'] && isset($rules_cat['category_meta']['categories_gmap_active']) && $rules_cat['category_meta']['categories_gmap_active'] ){
        $block_meeting_points = self::block_meeting_points($post);
        $output .= $block_meeting_points ? '<h3 class="babe_post_content_title">'.__( 'Meeting points', BABE_TEXTDOMAIN ).'</h3>'.$block_meeting_points : ( isset($post['address']['address']) && isset($post['address']['latitude']) && isset($post['address']['longitude']) && $post['address']['latitude'] && $post['address']['longitude'] ? '<h3 class="babe_post_content_title">'.__( 'Map', BABE_TEXTDOMAIN ).'</h3>'.self::block_address_map($post) : '' );
        }
        
        
        $block_services = !BABE_Settings::$settings['services_to_booking_form'] ? self::block_services($post) : '';
        $services_title = isset($rules_cat['category_meta']['categories_services_title']) && !empty($rules_cat['category_meta']['categories_services_title']) ? $rules_cat['category_meta']['categories_services_title'] : __( 'Services', BABE_TEXTDOMAIN );
        $output .= $block_services ? '<h3 class="babe_post_content_title">'.$services_title.'</h3>'.$block_services : '';
        
        $block_faq = self::block_faqs($post);
        $faq_title = isset($rules_cat['category_meta']['categories_faq_title']) && !empty($rules_cat['category_meta']['categories_faq_title']) ? $rules_cat['category_meta']['categories_faq_title'] : __( 'Questions & Answers', BABE_TEXTDOMAIN );
        $output .= $block_faq ? '<h3 class="babe_post_content_title">'.$faq_title.'</h3>'.$block_faq : '';
        
        //block_related
        $block_related = self::block_related($post);
        $block_related_title = apply_filters( 'babe_post_content_related_title', __( 'You may like', BABE_TEXTDOMAIN ));
        $output .= $block_related ? '<h3 class="babe_post_content_title">'.esc_html($block_related_title).'</h3>'.$block_related : '';    
        
        return $output; 
    }
    
///////////////////////////        
    /**
	 * Add price from to booking_obj page.
     * @param array $post
     * @return string
	 */
    public static function block_price_from($post){
        $output = '';
        
        $prices = BABE_Post_types::get_post_price_from($post['ID']);
    
    if (!empty($prices)){
        
        $save = '';
        
        if ($prices['discount_price_from'] < $prices['price_from']){
            
            $date_to_obj = new DateTime($prices['discount_date_to']);
            
            $save = '<span class="item_info_price_from_discount">'.BABE_Currency::get_currency_price($prices['price_from']).'</span><span class="item_info_price_from_save">'.__( 'Save ', BABE_TEXTDOMAIN ).$prices['discount'].'%</span>
            <div class="item_info_discount_expired"><i class="far fa-clock"></i> '.__( 'Offer Ends: ', BABE_TEXTDOMAIN ).$date_to_obj->format(get_option('date_format')).'</div>
            ';
        }
        
        $output .= '<div class="item_info_price">
    <label>'.__( 'From ', BABE_TEXTDOMAIN ).BABE_Currency::get_currency().'</label>
    <span class="item_info_price_from">'.BABE_Currency::get_currency_price($prices['discount_price_from']).'</span>'.$save.'
    
        <meta itemprop="name" content="'.esc_attr( get_the_title($post['ID']) ).'">
		<meta itemprop="description" content="'.esc_attr( strip_tags(BABE_Post_types::get_post_excerpt($post)) ).'">
		<meta itemprop="url" content="'.esc_url( get_permalink($post['ID']) ).'">
		
      <span itemprop="offers" itemscope itemtype="http://schema.org/Offer">
	    <meta itemprop="price" content="'.esc_attr( $prices['discount_price_from'] ).'" />
	    <meta itemprop="priceCurrency" content="'.esc_attr( BABE_Currency::get_currency() ).'" />
	    <link itemprop="availability" href="http://schema.org/InStock" />
      </span>
      <meta itemprop="image" content="'.esc_url( get_the_post_thumbnail_url($post['ID'], 'full') ).'">
      
    </div>';   
        
    }
    
        return $output; 
    }
    
///////////////////////////        
    /**
	 * Add unitegallery to booking_obj page.
     * @param array $post - we're looking for $post['images'] array here
     * @return string
	 */
    public static function block_slider($post){
    
    $output = '';
    
    $files = isset($post['images']) ? (array)$post['images'] : array();

    if(!BABE_Settings::$settings['unitegallery_remove'] && !empty($files)){
        
      $thumbnail = apply_filters('babe_slider_img_thumbnail', 'thumbnail');
      $full = apply_filters('babe_slider_img_full', 'full');     
      // Loop through them and output an image
      foreach ( $files as $file ) {
        if (is_array($file) && isset($file['image_id']) && $file['image_id']){
        $image_full_arr = wp_get_attachment_image_src( $file['image_id'], $full );
        $image_thumb_arr = wp_get_attachment_image_src( $file['image_id'], $thumbnail );
        $description = isset($file['description']) && $file['description'] ? ' data-description="'.$file['description'].'"' : '' ;
        
        $output .= '
        <img src="'.$image_thumb_arr[0].'" data-image="'.$image_full_arr[0].'"'.$description.'/>
        ';
        }
      } //// end foreach
      
      if ($output){
        
         $unitegallery_settings = BABE_Settings::$unitegallery;
         $js_arr = array();
         
         foreach($unitegallery_settings as $key => $value){
            
            if ($value === null){
                $value_str = 'null';
            } elseif ($value === true){
                $value_str = 'true';
            } elseif ($value === false){
                $value_str = 'false';
            } elseif (is_float($value) || is_int($value)){
                $value_str = $value;
            } else {
                $value_str = '"'.$value.'"';
            }
            
            $js_arr[] = $key.':'.$value_str;
         }
         $js = implode(', ', $js_arr);
         $output = '
         <div class="babe_slider" id="unitegallery" style="display:none;">
             '.$output.'
         </div>
         ';
      }
    
    }
    
    return $output;
}
    
////////////////////////////
    /**
	 * Add our content to pages.
     * @param string $content
     * @return string
	 */
    public static function pages_content($content){
        global $post;
        $output = $content;
        
        if (is_singular() && in_the_loop() && is_main_query()){

        if ($post->ID == intval(BABE_Settings::$settings['services_page']) && isset($_GET['current_action']) && $_GET['current_action'] == 'to_services'){        
            remove_filter( 'the_content', array( __CLASS__, 'pages_content'), 10, 1 );
            $output = apply_filters( 'babe_services_content', $content);
        }
        
        if ($post->ID == intval(BABE_Settings::$settings['checkout_page']) && isset($_GET['current_action']) && $_GET['current_action'] == 'to_checkout'){        
            remove_filter( 'the_content', array( __CLASS__, 'pages_content'), 10, 1 );
            $output = apply_filters( 'babe_checkout_content', $content);
        }
        
        if ($post->ID == intval(BABE_Settings::$settings['confirmation_page']) && isset($_GET['current_action']) && $_GET['current_action'] == 'to_confirm'){        
            remove_filter( 'the_content', array( __CLASS__, 'pages_content'), 10, 1 );
            $output = apply_filters( 'babe_confirmation_content', $content);
        }
        
        if ($post->ID == intval(BABE_Settings::$settings['admin_confirmation_page']) && isset($_GET['current_action']) && $_GET['current_action'] == 'to_admin_confirm'){        
            remove_filter( 'the_content', array( __CLASS__, 'pages_content'), 10, 1 );
            $output = apply_filters( 'babe_admin_confirmation_content', $content);
        }
        
        if ($post->ID == intval(BABE_Settings::$settings['my_account_page'])){        
            remove_filter( 'the_content', array( __CLASS__, 'pages_content'), 10, 1 );
            $output = apply_filters( 'babe_my_account_content', $content);
        }
        
        }
        
        return $output; 
    }    
    
///////////page_search_result///////////
    /**
	 * Add search result to page.
     * @param string $content
     * @return string
	 */
    public static function page_search_result($content){
        global $post;
        $output = $content;
        
        if (in_the_loop() && is_main_query()){
        
          $add_search_result_to_page = is_page() && $post->ID == BABE_Settings::$settings['search_result_page'];
          $add_search_result_to_page = apply_filters('babe_add_search_result_to_page', $add_search_result_to_page, $post);
        
          if ($add_search_result_to_page){
            remove_filter( 'the_content', array( __CLASS__, 'page_search_result'), 10, 1 );
            $output .= self::get_search_result(BABE_Settings::$settings['results_view']);
            
            $output .= '<div id="babe_search_result_refresh">
               <i class="fas fa-spinner fa-spin fa-3x"></i>
            </div>';
            
            $output = apply_filters('babe_search_result_content', $output, $post);
          }
        } 
        
        return $output; 
    }
    
///search_result_description_price////       
    /**
	 * Add price from and rating to search result items.
     * @param string $description
     * @param array $post
     * @return string
	 */
    public static function search_result_description_price($description, $post){
        $output = '';
        
        $output .= BABE_Rating::post_stars_rendering($post['ID']);
        
        $output .= self::block_price_from($post);
        
        $output .= $description;
    
        return $output; 
    }
    
////////////////////////////
    /**
	 * Get search result
     * @param string $view
     * @return string
	 */
    public static function get_search_result($view = 'full') {
        
        $output = '';
        
        $args = wp_parse_args( $_GET, array(
            'request_search_results' => '',
            'date_from' => '', //// d/m/Y or m/d/Y format
            'date_to' => '',
            'time_from' => '00:00',
            'time_to' => '00:00',
            'categories' => array(), //// term_taxonomy_ids from categories
            'terms' => array(), //// term_taxonomy_ids from custom taxonomies in $taxonomies_list
            'search_results_sort_by' => 'price_from_asc',
        ));
        
        $args = apply_filters('babe_search_result_args', $args);
        
        if ($args['request_search_results']){
            
           $args = BABE_Post_types::search_filter_to_get_posts_args($args);
        
        $posts = BABE_Post_types::get_posts($args);
        $posts_pages = BABE_Post_types::$get_posts_pages;
        
        $thumbnail = apply_filters('babe_search_result_img_thumbnail', 'ba-thumbnail-sq');
        $excerpt_length = apply_filters('babe_search_result_excerpt_length', 25);
        $excerpt_grid_length = apply_filters('babe_search_result_grid_excerpt_length', 13);
        
        foreach($posts as $post){
            
            $item_url = BABE_Functions::get_page_url_with_args($post['ID'], $_GET);
            
            $image_srcs = wp_get_attachment_image_src( get_post_thumbnail_id( $post['ID'] ), $thumbnail);
            $image = $image_srcs ? '<a href="'.$item_url.'"><img src="'.$image_srcs[0].'"></a>' : '';
            
            $price_old = $post['discount_price_from'] < $post['price_from'] ? '<span class="item_info_price_old">' . BABE_Currency::get_currency_price( $post['price_from'] ) . '</span>' : '';
				
			$discount = $post['discount'] ? '<div class="item_info_price_discount">-' . $post['discount'] . '%</div>' : '';
            
            $output .= $view == 'full' ? apply_filters('babe_search_result_view_full', '
          <div class="block_search_res">
            <div class="search_res_img">
            '.$image.'
            </div>
            <div class="search_res_text">
              <a href="'.$item_url.'"><h3 class="search_res_title">
              '. apply_filters('translate_text', $post['post_title']) .'
              </h3></a>
              <div class="search_res_description">
              '.apply_filters('babe_search_result_description', BABE_Post_types::get_post_excerpt($post, $excerpt_length), $post).'
              </div>
              <div class="search_res_actions">
              </div>
            </div>
           </div>
           ', $post, $image) : apply_filters('babe_search_result_view_grid', '
           <div class="babe_all_items_item block_search_res_grid">
				<div class="babe_all_items_item_inner">
					<div class="item_img related_item_img">
						'.$image.'
					</div>
					<div class="item_text related_item_text">
                        <div class="item_title related_item_title">
                            <a href="' . $item_url . '">' . apply_filters('translate_text', $post['post_title']) . '</a>
                            ' . BABE_Rating::post_stars_rendering( $post['ID'] ) . '
                        </div>
						<div class="item_info_price">
							<label>' . __( 'from', BABE_TEXTDOMAIN ) . '</label>
							' . $price_old . '
							<span class="item_info_price_new">' . BABE_Currency::get_currency_price( $post['discount_price_from'] ) . '</span>
                            ' . $discount . ' 
						</div>
								
						<div class="item_description">
							' . apply_filters('babe_search_result_grid_description', BABE_Post_types::get_post_excerpt($post, $excerpt_grid_length), $post) . '
						</div>
					</div>
				</div>
			</div>
            ', $post, $image);
        } /// end foreach $posts
        
        if ($output){
            
            $sort_by_filter = self::input_select_field('sr_sort_by', '', BABE_Post_types::get_search_filter_sort_by_args(), $args['search_results_sort_by']);
            
            $inner_class = apply_filters('babe_search_result_inner_class', 'babe_search_results_inner babe_search_results_inner_'.$view);  
            
            $output = '<div class="babe_search_results">
            <div class="babe_search_results_filters">
              '.$sort_by_filter.'
            </div>
            <div class="'.esc_attr($inner_class).'">
            '.$output.'
            </div>
            </div>';
        }
        
        $output .= BABE_Functions::pager($posts_pages);
        
        $output = apply_filters('babe_search_result_html', $output, $posts, $posts_pages);
        
        }
        
        return $output;
    }
    
/////////////get_search_form///////////////
    /**
	 * Get search form html.
     * @param string $title
     * @return string
	 */
    public static function get_search_form($title = ''){
   
   $output = '';
   
   $date_from = isset($_GET['date_from']) ? $_GET['date_from'] : '';
   $date_to = isset($_GET['date_to']) ? $_GET['date_to'] : '';
   
   $action = isset($_GET['same_page']) ? '' : BABE_Settings::get_search_result_page_url();
   
   $same_page = isset($_GET['same_page']) ? '<input type="hidden" name="same_page" value="'.$_GET['same_page'].'">' : '';
   
   $min_price = isset($_GET['min_price']) && $_GET['min_price'] ? '<input type="hidden" name="min_price" value="'.$_GET['min_price'].'">' : '';
   $max_price = isset($_GET['max_price']) && $_GET['max_price'] ? '<input type="hidden" name="max_price" value="'.$_GET['max_price'].'">' : '';
   
   $terms = isset($_GET['terms']) && is_array($_GET['terms']) && !empty($_GET['terms']) ? array_map('intval', $_GET['terms']) : array();
   
   $term_inputs = '';
   
   if (!empty($terms)){
      foreach ($terms as $term_taxonomy_id){
        $term_inputs .= '
          <input type="hidden" name="terms['.$term_taxonomy_id.']" value="'.$term_taxonomy_id.'">
        ';
      }
   }
   
   $search_filter_sort_by = isset($_GET['search_results_sort_by']) && isset(BABE_Post_types::$search_filter_sort_by_args[$_GET['search_results_sort_by']]) ? '
          <input type="hidden" name="search_results_sort_by" value="'.$_GET['search_results_sort_by'].'">
        ' : '<input type="hidden" name="search_results_sort_by" value="price_from_asc">';
        
   $hidden_fields = '<input type="hidden" name="request_search_results" value="1">
                '.$same_page.$min_price.$max_price.$term_inputs.$search_filter_sort_by;     
   
   //// place search form code here
   $output .= '<div id="search-box">						
				<div class="search-box-header">
					'.apply_filters('babe_search_form_header', $title).'	
				</div>
			
						
		<form name="search_form" action="'.$action.'" method="get" id="search_form">
			<div class="input-group">
					'.apply_filters('babe_search_form_before_date_fields', '').'
                    
					<div class="search-date">
                        <i class="far fa-calendar-alt"></i>
						<input type="text" class="search_date" id="date_from" name="date_from" value="'.$date_from.'" placeholder="'.apply_filters('babe_search_form_date_from_title', __( 'Date from', BABE_TEXTDOMAIN )).'">
					</div>
                    
                    <div class="search-date">
                        <i class="far fa-calendar-alt"></i>
						<input type="text" class="search_date" id="date_to" name="date_to" value="'.$date_to.'" placeholder="'.apply_filters('babe_search_form_date_to_title', __( 'Date to', BABE_TEXTDOMAIN )).'">
					</div>
                    
                    '.apply_filters('babe_search_form_after_date_fields', '').'
                    
                    <div class="submit">
					  <button name="submit" class="btn btn-primary btn-search" value="1"><i class="fas fa-search"></i> '.apply_filters('babe_search_form_submit_title', __( 'Search', BABE_TEXTDOMAIN )).'</button>
				    </div>
				</div>
                
                '.apply_filters('babe_search_form_before_hidden_fields', '').'
                
                '.$hidden_fields.'   
		</form>
					</div>';
                    
        $output = apply_filters('babe_search_form_html', $output, $hidden_fields, $title);         
    
   return $output; 
   
   }                
    
////////////////////////////
    /**
	 * Add steps to booking_obj page.
     * @param array $post
     * @return string
	 */
    public static function block_steps($post){

        $output = '';
        $results = array();
        
        if (!empty($post) && isset($post['steps']) && !empty($post['steps'])){
           
              foreach($post['steps'] as $step){
                if (isset($step['attraction']) && isset($step['title'])){
                $step_block = '<div class="block_step">
                <div class="block_step_title collapse-title">
                <h4>'.apply_filters('translate_text', $step['title']).'</h4>
                <span><i class="fas fa-chevron-down"></i></span>
                </div>
                <div class="block_step_content collapse-body">
                ' . apply_filters('the_content', $step['attraction']) . '
                </div>
              </div>';
                $results[] = apply_filters('babe_post_step_block_html', $step_block, $step);
                }
              }
              
              $output .= '<div id="block_steps">
              '.implode('', $results).'
              </div>';
            
        } //// end if !empty($post['steps'])    
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Add FAQs to booking_obj page.
     * 
     * @param array $post - BABE post
     * @return string
	 */
    public static function block_faqs($post){

        $output = '';
        $results = array();
        
        if (!empty($post) && isset($post['faq']) && !empty($post['faq'])){
            
             $faqs_arr = BABE_Post_types::get_post_faq($post);
             
             if (!empty($faqs_arr)){
                
                $i = 0;
                
              foreach($faqs_arr as $faq){
                
                $add_class = '';
                /// add class 'block_active' if we need to open item by default
                //$add_class = !$i ? ' block_active' : '';
                $add_class = apply_filters('babe_post_faq_block_html_active_item', $add_class, $faq, $i);
                
                $qa_block = '<div class="block_faq accordion-block'.$add_class.'">
                <div class="block_faq_title accordion-title">
                <h4>'.apply_filters('translate_text', $faq['post_title']).'</h4>
                <span><i class="fas fa-chevron-down"></i></span>
                </div>
                <div class="block_faq_content accordion-body">
                '.apply_filters('the_content', $faq['post_content']).'
                </div>
              </div>';
                $results[] = apply_filters('babe_post_faq_block_html', $qa_block, $faq, $i);
                $i++;
              }
              
              $output .= '<div id="block_faqs">
              '.implode('', $results).'
              </div>';
                
             }
   
        } //// end if !empty($post['faq'])    
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Add related items to booking_obj page
     * 
     * @param array $post - BABE post
     * @return string
	 */
    public static function block_related($post) {
        
        $output = '';
        $results = array();
        
        if (!empty($post) && isset($post['related_items']) && !empty($post['related_items'])){
            
          $related_arr = BABE_Post_types::get_post_related($post);
          
          $thumbnail = apply_filters('babe_post_related_item_thumbnail', 'ba-thumbnail-sq');
          $excerpt_length = apply_filters('post_related_item_excerpt_length', 13);
        
          foreach($related_arr as $related_post){
            
            $item_url = BABE_Functions::get_page_url_with_args($related_post['ID'], $_GET);
            
            $image_srcs = wp_get_attachment_image_src( get_post_thumbnail_id( $related_post['ID'] ), $thumbnail);
            $image = $image_srcs ? '<a href="'.$item_url.'"><img src="'.$image_srcs[0].'"></a>' : '';
            
            $price_old = $related_post['discount_price_from'] < $related_post['price_from'] ? '<span class="item_info_price_old">' . BABE_Currency::get_currency_price( $related_post['price_from'] ) . '</span>' : '';
				
			$discount = $related_post['discount'] ? '<div class="item_info_price_discount">-' . $related_post['discount'] . '%</div>' : '';
            
            $results[] = apply_filters('babe_post_related_item_html', '
          <div class="babe_all_items_item block_related_item">
				<div class="babe_all_items_item_inner">
					<div class="item_img related_item_img">
						'.$image.'
					</div>
					<div class="item_text related_item_text">
                        <div class="item_title related_item_title">
                            <a href="' . $item_url . '">' . apply_filters('translate_text', $related_post['post_title']) . '</a>
                            ' . BABE_Rating::post_stars_rendering( $related_post['ID'] ) . '
                        </div>
						<div class="item_info_price">
							<label>' . __( 'from', BABE_TEXTDOMAIN ) . '</label>
							' . $price_old . '
							<span class="item_info_price_new">' . BABE_Currency::get_currency_price( $related_post['discount_price_from'] ) . '</span>
                            ' . $discount . ' 
						</div>
								
						<div class="item_description related_item_description">
							' . apply_filters('babe_post_related_item_description', BABE_Post_types::get_post_excerpt($related_post, $excerpt_length), $related_post) . '
						</div>
					</div>
				</div>
			</div>
           ', $related_post, $image);
           
          } /// end foreach $related_post
        
          if (!empty($results)){
            
             $output .= '<div id="block_related">
              <div class="babe_shortcode_block_inner">
              '.implode('', $results).'
              </div>
            </div>';
          }
        
          $output = apply_filters('babe_post_related_block_html', $output, $related_arr);
        
        }
        
        return $output;
    }    
    
///////////////////////////////   
/////ajax_get_meeting_points////    
    /**
	 * Get post meeting points as formated string.
     * @return string
	 */
    public static function ajax_get_meeting_points() {
        $output = '';
        
        $results = array();
        
        if (isset($_POST['post_id']) && BABE_Post_types::is_post_booking_obj($_POST['post_id']) && isset($_POST['lat']) && isset($_POST['lng']) && isset($_POST['nonce']) && wp_verify_nonce( $_POST['nonce'], self::$nonce_title)){
            
          $post_id = intval($_POST['post_id']);
          $post = BABE_Post_types::get_post($post_id);
          $lat = floatval($_POST['lat']);
          $lng = floatval($_POST['lng']);
          
          if (!empty($post) && isset($post['meeting_points']) && isset($post['meeting_place']) && $post['meeting_place'] == 'point'){
            
           $meeting_points = BABE_Post_types::get_post_meeting_points($post);
           
           if (!empty($meeting_points)){
              foreach($meeting_points as $point_id => $meeting_point){      
                $distance = BABE_Functions::distance($meeting_point['lat'], $meeting_point['lng'], $lat, $lng);
                $distance = intval($distance*1000000);
                $results[$distance] = '<div class="meeting_point" data-point-id="'.$point_id.'">
                <div class="meeting_point_description">
                <h4>'.implode(', ', $meeting_point['times']).' '.$meeting_point['address'].'</h4>
                '.$meeting_point['description'].'
                </div>
                <button class="btn button add_destination" data-lat="'.$meeting_point['lat'].'" data-lng="'.$meeting_point['lng'].'" data-address="'.$meeting_point['address'].'" data-point-id="'.$point_id.'">'.__('Select address', BABE_TEXTDOMAIN).'</button>
              </div>';
              }
              
              /// sort results
              if (!empty($results)){
                ksort($results, SORT_NUMERIC);
                $results = array_slice($results, 0, 5, true);
              }
              
              $output .= '<h4>'.__('Select meeting point', BABE_TEXTDOMAIN).'<a href="#booking_form">'.__('Go to Booking form', BABE_TEXTDOMAIN).'</a></h4>'.implode('', $results);
            
           } //// end if !empty($meeting_points)
            
          } //// end if !empty($post) 
        }
        echo $output;
        
        wp_die();
    }

////////////////////////////////    
/////ajax_booking_calculate////    
    /**
	 * Get booking price.
     * @return
	 */
    public static function ajax_booking_calculate() {
        $output = '';
        
        if (isset($_POST['post_id']) && BABE_Post_types::is_post_booking_obj($_POST['post_id']) && isset($_POST['date_from']) && isset($_POST['date_to']) && isset($_POST['nonce']) && wp_verify_nonce( $_POST['nonce'], self::$nonce_title)){
            
          $post_id = intval($_POST['post_id']);
          
          $data_arr = array();
          
          if(isset($_POST['data'])){
              parse_str($_POST['data'], $data_arr);
          }
          
          $guests = isset($data_arr['booking_guests']) && !empty($data_arr['booking_guests']) && is_array($data_arr['booking_guests']) ? $data_arr['booking_guests'] : array( 0 => 1);
          $services = isset($data_arr['booking_services']) && is_array($data_arr['booking_services']) ? $data_arr['booking_services'] : array(); 
          
          $date_from = BABE_Calendar_functions::isValidDate($_POST['date_from'], BABE_Settings::$settings['date_format']) ? BABE_Calendar_functions::date_to_sql($_POST['date_from']) : ''; /// now in Y-m-d format
          $date_to = BABE_Calendar_functions::isValidDate($_POST['date_to'], BABE_Settings::$settings['date_format']) ? BABE_Calendar_functions::date_to_sql($_POST['date_to']) : $date_from; /// now in Y-m-d format
          $time_from = isset($_POST['time_from']) && BABE_Calendar_functions::isValidTime($_POST['time_from'], 'H:i') ? ' '.$_POST['time_from'] : '';
          $time_to = isset($_POST['time_to']) && BABE_Calendar_functions::isValidTime($_POST['time_to'], 'H:i') ? ' '.$_POST['time_to'] : ' ';
          
          $date_from = $date_from.$time_from;
          $date_to = $date_to.$time_to;
          
          if ($date_from){
             $price_arr = BABE_Prices::get_obj_total_price_arr($post_id, $date_from, $guests, $date_to, $services);
             $price = BABE_Prices::get_obj_total_price($post_id, $price_arr);
             $output = BABE_Currency::get_currency_price($price['total_with_taxes']);
             
             $args = array(
                'post_id' => $post_id,
                'date_from' => $date_from,
                'date_to' => $date_to,
                'guests' => $guests,
                'services' => $services,
                'data_arr' => $data_arr,
                'price_arr' => $price_arr,
                'price' => $price,
             );
             
             $output = apply_filters('ajax_babe_booking_calculate_price', $output, $args); 
          }
    
        }
        
        echo $output;
        
        wp_die();
    }        

//////////////////////////////    
/////ajax_get_times_guests////    
    /**
	 * Get available times and guests select for booking form.
     * @return
	 */
    public static function ajax_get_times_guests() {
        $output = array();
        $output['av_guests'] = 0;
        $output['time_lines'] = '';
        $output['select_guests'] = '';
        
        if (isset($_POST['post_id']) && BABE_Post_types::is_post_booking_obj($_POST['post_id']) && isset($_POST['date_from']) && isset($_POST['date_to'])&& isset($_POST['nonce']) && wp_verify_nonce( $_POST['nonce'], self::$nonce_title)){
            
          $post_id = intval($_POST['post_id']);
          
          $date_from = BABE_Calendar_functions::isValidDate($_POST['date_from'], BABE_Settings::$settings['date_format']) ? BABE_Calendar_functions::date_to_sql($_POST['date_from']) : ''; /// now in Y-m-d format
          $date_to = BABE_Calendar_functions::isValidDate($_POST['date_to'], BABE_Settings::$settings['date_format']) ? BABE_Calendar_functions::date_to_sql($_POST['date_to']) : ''; /// now in Y-m-d format
          if ($date_from){
            ///// get rules
            $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
            
            if ($rules_cat['rules']['basic_booking_period'] == 'recurrent_custom'){
                
                $av_times_arr = self::booking_form_av_times($post_id, $date_from);
                if(!empty($av_times_arr)){
                    $output = $av_times_arr;
                } else {
                    $output['av_guests'] = 0;
                    $output['time_lines'] = '';
                }
                
            } else {
                //// or av_guests
                $output['av_guests'] = BABE_Calendar_functions::get_av_guests($post_id, $date_from, $date_to);
                $output['time_lines'] = '';
                
            }
            
            $guests = isset( $_POST['guests'] ) && is_array( $_POST['guests'] ) ? $_POST['guests'] : array();
            
            if (!empty($guests)){
                
                $guests = array_map('absint', $guests);
                
            } 
            
            //// booking_form_select_guests
            $output['select_guests'] = self::booking_form_select_guests($post_id, $output['av_guests'], $date_from, $date_to, $guests);
            
          }
    
        }
        
        echo json_encode($output);
        
        wp_die();
    }
    
/////ajax_get_booking_times////    
    /**
	 * Get available booking times select for booking form.
     * @return
	 */
    public static function ajax_get_booking_times() {
        
        $output = '';
        
        if (isset($_POST['post_id']) && BABE_Post_types::is_post_booking_obj($_POST['post_id']) && isset($_POST['date_from']) && isset($_POST['start_time']) && isset($_POST['nonce']) && wp_verify_nonce( $_POST['nonce'], self::$nonce_title)){
            
          $post_id = intval($_POST['post_id']);
          $start_time = $_POST['start_time'] == 'true' ? true: false;
          
          $date_from = BABE_Calendar_functions::isValidDate($_POST['date_from'], BABE_Settings::$settings['date_format']) ? $_POST['date_from'] : ''; /// now in Y-m-d format
          
          $time_from = isset($_POST['time_from']) && BABE_Calendar_functions::isValidTime($_POST['time_from'], 'H:i') ? $_POST['time_from'] : false;
          
          if ($date_from){
            ///// get rules
            $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
            
            if ($rules_cat['rules']['basic_booking_period'] == 'day'){
                $field_name = $start_time ? 'booking_time_from' : 'booking_time_to';
                $time_select_arr = self::get_time_select_arr($date_from, $post_id, $start_time);
                $output = self::input_select_field($field_name, '', $time_select_arr, $time_from);
            }
          }
    
        }
        
        echo $output;
        
        wp_die();
    }        
    
////////////////////////////
    /**
	 * Create av times radio input.
     * 
     * @param int $post_id
     * @param string $date_from - Y-m-d H:i:s, must be valid
     * @param array $order_item_args
     * 
     * @return string
	 */
    public static function booking_form_av_times($post_id, $date_from, $order_item_args = array()){
        
        $output = array();
        
        $date_from_obj = new DateTime($date_from);
        $av_cal = BABE_Calendar_functions::get_av_cal($post_id, $date_from_obj->format('Y-m-d'), $date_from_obj->format('Y-m-d'), $order_item_args);
        $max_guests = abs(intval(get_post_meta( $post_id, 'guests', true )));
        
        if (isset($order_item_args['date_from'])){
            
            $test_date_from_obj = new DateTime($order_item_args['date_from']);
            
            $test_time = $test_date_from_obj->format('H:i');
            
        } else {
            
            $test_time = $date_from_obj->format('H:i');
            
        }
        
        $output['time_lines'] = '';
        $output['av_guests'] = 0;
        
        if (!empty($av_cal) && isset($av_cal[$date_from_obj->format('Y-m-d')]['times'])){
            $i = 0;
            foreach($av_cal[$date_from_obj->format('Y-m-d')]['times'] as $time => $av_guests){
                
                if ((!$i && !isset($av_cal[$date_from_obj->format('Y-m-d')]['times'][$test_time])) || (isset($av_cal[$date_from_obj->format('Y-m-d')]['times'][$test_time]) && $test_time == $time)){
                    $output['av_guests'] = $av_guests;
                    $checked = ' checked="checked"';
                } else {
                    $checked = '';
                }
                $i++;
                
                $output['time_lines'] .= '
              <span class="booking_time_line">
                <input type="radio" class="booking_time" name="booking_time" value="'.$time.'" id="booking_time_'.$i.'" data-max-guests="'.$av_guests.'" data-max-select-guests="'.min($av_guests, BABE_Settings::$settings['max_guests_select']).'"'.$checked.'>
                <label for="booking_time_'.$i.'">'.$time.'</label>
              </span>';
              
            }
        }
        
        return $output;
        
    }    
    
////////////////////////////
    /**
	 * Create select guests input fields.
     * 
     * @param int $post_id
     * @param int $max_guests
     * @param string $date_from - Y-m-d H:i:s, must be valid
     * @param string $date_to - Y-m-d H:i:s, must be valid
     * @param array $selected_guests_arr - [$age_id => $guests_num]
     * 
     * @return string
	 */
    public static function booking_form_select_guests($post_id, $max_guests = 0, $date_from = '', $date_to ='', $selected_guests_arr = array()){
        
        $output = '';
        
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
        
        $max_guests = !$max_guests ? absint(get_post_meta($post_id, 'guests', true)) : absint($max_guests);
        
        if ($max_guests){
            $guests_total = min($max_guests, BABE_Settings::$settings['max_guests_select']);
            
            $ages = BABE_Post_types::get_ages_arr();
            $post_ages = BABE_Post_types::get_post_ages($post_id);
            
            if (empty($post_ages)){
                
               if (!$rules_cat['rules']['ages'] || empty($ages)){
                
                   $post_ages[0] = array(
                    'name' => '',
                    'description' => '',
                   );
                
               } else {
                
                   $post_ages = $ages;
                
               }
            }
            
            foreach ($post_ages as $age_id => $age_term){
                
                $age_term['description'] = $age_term['description'] ? '('.$age_term['description'].')' : '';
                
                $field_title = $age_term['name'] ? '<div class="input_select_title_value">'. $age_term['name'] . $age_term['description'] . '</div>' : '';
                
                if (($rules_cat['rules']['basic_booking_period'] == 'recurrent_custom' || $rules_cat['rules']['booking_mode'] == 'tickets' || $rules_cat['rules']['booking_mode'] == 'places') && $date_from){
                    
                    $price_arr = BABE_Prices::get_obj_total_price_arr($post_id, $date_from, array( $age_id => 1), $date_to, array());
                    $price = BABE_Prices::get_obj_total_price($post_id, $price_arr);
                    $price_html = BABE_Currency::get_currency_price($price['total_with_taxes']);
                    
                } else {
                    $price_html = '';
                }
                
                $selected_value = isset($selected_guests_arr[$age_id]) ? $selected_guests_arr[$age_id] : 0;
                
                $output .= '
						<div class="select_guests_block input_select_field">
							<div class="input_select_title">
                                 ' . $field_title . '
                                 <div class="input_select_wrapper">
                                    <input type="text" id="guests_'.$age_id.'" class="input_select_input input_select_input_value select_guests" name="booking_guests['.$age_id.']" data-age-id="'.$age_id.'" value="'.$selected_value.'">
                                    
                                    
                                    
                                    <ul class="input_select_list">
                                    '.self::get_range_input_select_options(0, $guests_total, 1, $selected_value).'
                                    </ul>
                                    <i class="fas fa-chevron-down"></i>
                                 </div>
                                 '.$price_html.'  
                            </div>
						</div>
					'; 
           }
            
        }
        
        return $output;
        
    }    
    
////////////////////////////
    /**
	 * Add booking form to booking_obj page.
     * @return string
	 */
    public static function booking_form($booking_obj_id = 0){
        
        $booking_obj_id = absint($booking_obj_id);
        
        if ($booking_obj_id && BABE_Post_types::is_post_booking_obj($booking_obj_id)){
            
            $post = get_post($booking_obj_id);
            
        } else {
            
            global $post;
        
        }

        $output = '';
        
        if ($post->post_type == BABE_Post_types::$booking_obj_post_type){
            
            $post_id = $post->ID;
            
            $babe_post = BABE_Post_types::get_post($post_id);
            
            $action = isset($babe_post['services']) && !empty($babe_post['services']) && !BABE_Settings::$settings['services_to_booking_form'] ? 'to_services' : 'to_checkout';
            
            $action = apply_filters('babe_booking_form_action', $action, $babe_post);
            
            ///// get rules
            $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
            
            ////// check dates for one time event
            if ($rules_cat['rules']['basic_booking_period'] == 'single_custom'){
                              
               $current_date_obj = BABE_Functions::datetime_local();
               $date_from_obj = new DateTime( BABE_Calendar_functions::date_to_sql($babe_post['start_date']).' '.$babe_post['start_time']);
               
               if ($current_date_obj >= $date_from_obj){
                
                 return $output;
                
               }
               
            }
            ///// get av times
            $av_times = BABE_Post_types::get_post_av_times($babe_post);
            
            $modal_meeting_points = '';
            
            $i = 1;
            
            /////////date fields
            
            $date_from = isset($_GET['date_from']) && BABE_Calendar_functions::isValidDate($_GET['date_from'], BABE_Settings::$settings['date_format']) ? $_GET['date_from'] : '';
            $date_to = isset($_GET['date_to']) && BABE_Calendar_functions::isValidDate($_GET['date_to'], BABE_Settings::$settings['date_format']) ? $_GET['date_to'] : '';
            
            $input_time_from = '';
            $input_time_to = '';
            
            if ($rules_cat['rules']['basic_booking_period'] == 'day'){
                $time_select_arr = self::get_time_select_arr($date_from, $post_id, true);
                $input_time_from = '<div id="booking_time_from_block" class="booking-time-block">
                   '.self::input_select_field('booking_time_from', '', $time_select_arr, (isset($_GET['time_from']) ? $_GET['time_from'] : false)).'
                   </div>';
                $time_select_arr = self::get_time_select_arr($date_to, $post_id, false);
                $input_time_to = '<div id="booking_time_to_block" class="booking-time-block">
                   '.self::input_select_field('booking_time_to', '', $time_select_arr, (isset($_GET['time_to']) ? $_GET['time_to'] : false)).'
                   </div>';
            }
            
            $input_fields = array();
            
            $input_fields = apply_filters('babe_booking_form_before_date_from', $input_fields, $babe_post, $av_times, $rules_cat);
            
            if ($rules_cat['rules']['basic_booking_period'] == 'single_custom'){
                
                if (isset($babe_post['start_time']) && $babe_post['start_time'] && isset($babe_post['end_time']) && $babe_post['end_time']):
                /////////////////
                
                $date_to_obj = new DateTime( BABE_Calendar_functions::date_to_sql($babe_post['end_date']).' '.$babe_post['end_time']);
                $dates = $date_from_obj->format(get_option('date_format').' '.get_option('time_format')).' - ';
                if ( $date_from_obj->format('Y-m-d') != $date_to_obj->format('Y-m-d') ){
                    $dates .= $date_to_obj->format(get_option('date_format')).' ';
                }
                $dates .= $date_to_obj->format( get_option('time_format') );
                
                $input_time_from = '<input type="hidden" name="booking_time_from" id="booking_time_from" value="'.$date_from_obj->format('H:i').'"><input type="hidden" name="booking_time_to" id="booking_time_to" value="'.$date_to_obj->format('H:i').'"><input type="hidden" id="booking_date_from" name="booking_date_from" value="'.$babe_post['start_date'].'" data-post-id="'.$post_id.'"><input type="hidden" id="booking_date_to" name="booking_date_to" value="'.$babe_post['end_date'].'">';
                
                $input_fields[] = '
            <div class="booking-form-block booking-date-block">
                <label class="booking_form_input_label"><span class="booking_form_step_num">'.$i.'</span><i class="far fa-calendar-alt"></i></label>
            <div class="booking-date">
                   '.$dates.'
                   '.$input_time_from.'
			</div>
            
            </div>';
                $i++;
                
                endif;
                
            } else {
         
            $input_fields[] = '
            <div class="booking-form-block booking-date-block">
                <label class="booking_form_input_label"><span class="booking_form_step_num">'.$i.'</span>'.__('From:', BABE_TEXTDOMAIN).'</label>
            <div class="booking-date">
                   <i class="far fa-calendar-alt"></i>
				   <input type="text" class="booking_date" id="booking_date_from" name="booking_date_from" value="'.$date_from.'" placeholder="'.apply_filters('babe_booking_form_date_from_placeholder', '').'" data-post-id="'.$post_id.'">
                   '.$input_time_from.'
			</div>
            
            </div>';
            $i++;
            
            }
            
            $input_fields = apply_filters('babe_booking_form_after_date_from', $input_fields, $babe_post, $av_times, $rules_cat);
            
            if ($rules_cat['rules']['basic_booking_period'] != 'recurrent_custom' && $rules_cat['rules']['basic_booking_period'] != 'single_custom'){
                $input_fields[] = '
                <div class="booking-form-block booking-date-block">
                <label class="booking_form_input_label"><span class="booking_form_step_num">'.$i.'</span>'.__('To:', BABE_TEXTDOMAIN).'</label>
            <div class="booking-date">
                   <i class="far fa-calendar-alt"></i>
				   <input type="text" class="booking_date" id="booking_date_to" name="booking_date_to" value="'.$date_to.'" placeholder="'.apply_filters('babe_booking_form_date_to_placeholder', '').'" data-post-id="'.$post_id.'">
                   '.$input_time_to.'
			</div>
            </div>';
                 $i++;
                 
                 $input_fields = apply_filters('babe_booking_form_after_date_to', $input_fields, $babe_post, $av_times, $rules_cat);
                 
            }
            
            $check_add_av_times = $rules_cat['rules']['basic_booking_period'] == 'recurrent_custom';
            $check_add_av_times = apply_filters('babe_booking_form_check_add_av_times', $check_add_av_times, $av_times, $babe_post, $rules_cat);
            
            ////////////Time fields///////////
            if ($check_add_av_times){
                
                //// get AV time spans by AJAX
                $input_fields[] = '<div class="booking-form-block booking-times-block">
                <label class="booking_form_input_label"><span class="booking_form_step_num">'.$i.'</span>'.__('Time:', BABE_TEXTDOMAIN).'</label>
                <div id="booking-times" class="booking-date-times">
			    </div>
                </div>';
                
                $i++;
                
                $input_fields = apply_filters('babe_booking_form_after_av_times', $input_fields, $babe_post, $av_times, $rules_cat);
                
            }
            //////////////Guests fields/////////
            
            if (!isset($rules_cat['category_meta']['categories_remove_guests']) || !$rules_cat['category_meta']['categories_remove_guests']){
                
              $guests = isset( $_GET['guests'] ) && is_array( $_GET['guests'] ) ? $_GET['guests'] : array();  
            
              if (!empty($guests) && $date_from && $rules_cat['rules']['basic_booking_period'] != 'recurrent_custom'){
                
                $date_from_sql = BABE_Calendar_functions::date_to_sql($date_from);
                
                $date_to_sql = $date_to ? BABE_Calendar_functions::date_to_sql($date_to) : $date_to;
                
                $av_guests = BABE_Calendar_functions::get_av_guests($post_id, $date_from_sql, $date_to_sql);
                
                $guests = array_map('absint', $guests);
                
                $guests_output = self::booking_form_select_guests($post_id, $av_guests, $date_from_sql, $date_to_sql, $guests);
                
              } else {
                
                $guests_output = __('please, select date first', BABE_TEXTDOMAIN);
                
              }
            
            $guests_title = $rules_cat['rules']['booking_mode'] == 'tickets' ? __('Tickets:', BABE_TEXTDOMAIN) : __('Guests:', BABE_TEXTDOMAIN);
            
            $input_fields[] = '
            <div class="booking-form-block booking-guests-block">
            <label class="booking_form_input_label"><span class="booking_form_step_num">'.$i.'</span>'.$guests_title.'</label>
            <div id="booking-guests-result">
            '.$guests_output.'
            </div>
            </div>';
            $i++;
            
            $input_fields = apply_filters('babe_booking_form_after_guests', $input_fields, $babe_post, $av_times, $rules_cat);
            
            }
            
            ////////////Meeting points///////////
            
            if (BABE_Settings::$settings['mpoints_active'] && !empty($babe_post) && isset($babe_post['meeting_points']) && isset($babe_post['meeting_place']) && $babe_post['meeting_place'] == 'point'){
            
            $meeting_points = BABE_Post_types::get_post_meeting_points($babe_post);
           
             if (!empty($meeting_points)){
                $meeting_points_output = array();
              foreach($meeting_points as $point_id => $meeting_point){      
                $meeting_points_output[] = '<div class="booking_meeting_point_line">
                <input type="radio" class="booking_meeting_point" name="booking_meeting_point" value="'.$point_id.'" id="booking_meeting_point_'.$point_id.'" data-point-id="'.$point_id.'">
                <label for="booking_meeting_point_'.$point_id.'">'.implode(', ', $meeting_point['times']).' - <a href="'.$meeting_point['permalink'].'" target="_blank" open-mode="modal" data-obj-id="'.$point_id.'" data-lat="'.$meeting_point['lat'].'" data-lng="'.$meeting_point['lng'].'" data-address="'.$meeting_point['address'].'" >'.$meeting_point['address'].'</a></label>
              </div>';
              }
              
              $find_closes_loc_text = BABE_Settings::$settings['google_map_remove'] || is_admin() ? '' : ' (' . '<a href="#block_meeting_points">'.__('find closest location', BABE_TEXTDOMAIN).'</a>'.')';
              
              $input_fields[] = apply_filters('babe_booking_form_meeting_points', '<div class="booking-form-block booking-meeting-point">
              <label class="booking_form_input_label"><span class="booking_form_step_num">'.$i.'</span>'.__('Select meeting point', BABE_TEXTDOMAIN). $find_closes_loc_text .':</label>
              '.implode(' ', $meeting_points_output).'
              </div>', $meeting_points_output, $meeting_points, $babe_post, $i);
              $i++;
              
              $input_fields = apply_filters('babe_booking_form_after_meeting_points', $input_fields, $babe_post, $av_times, $rules_cat);
              
              if (!is_admin()){
              
              $modal_meeting_points = '<div id="babe_overlay_container">
            <div id="block_address_map_with_direction" class="babe_overlay_inner">
              <span id="modal_close"><i class="fas fa-times"></i></span>
              
                <h3>'.__('Find a route from your location', BABE_TEXTDOMAIN).'</h3>
              
                <div id="google_map_address_with_direction" data-obj-id="" data-lat="" data-lng="" data-address="">
                </div>
                
                <div id="route_to_buttons">
                    <button id="route_to_button_ok" data-point-id="" class="btn button route_to_point_button">'.__('Ok', BABE_TEXTDOMAIN).'</button>
                </div>  

            </div>
          </div>
          <div id="babe_overlay"></div>';
          
              }
            
             } //// end if !empty($meeting_points) 
           }
           
           /////////////////////////////////////
           
           if (BABE_Settings::$settings['services_to_booking_form']){
            
              $services_html = self::list_add_services($babe_post);
           
             if ($services_html){
              $input_fields[] = '
              <div class="booking-form-block booking-services-block">
               <label class="booking_form_input_label">'.__('Add Extra', BABE_TEXTDOMAIN).'</label>
               <div class="booking_services_inner">
               '.$services_html.'
               </div>
              </div>';
             }
            
           }
            
            ////////////////////////////////////
            
            $input_fields = apply_filters('babe_booking_form_input_fields', $input_fields, $babe_post, $av_times, $rules_cat);
            
            $after_hidden_fields = apply_filters('babe_booking_form_after_hidden_fields', '', $babe_post, $av_times, $rules_cat);
            
            $output .= '<form id="booking_form" name="booking_form" method="post" action="" data-post-id="'.$post_id.'" class="booking_form_type_'.$rules_cat['rules']['basic_booking_period'].'">
            
            <div class="input_group">
            
            '.implode('', $input_fields).'
            
            </div>
            
            <div id="total_group">
                <label class="booking_form_input_label">'.__('Total:', BABE_TEXTDOMAIN).'</label>
                <div id="booking_form_total">
                </div>
            </div>
            
            <div id="error_group">
                <label class="booking_form_error_label">'.__('Please fill in all the data.', BABE_TEXTDOMAIN).'</label>
            </div>
            
            <input type="hidden" name="booking_obj_id" value="'.$post_id.'">
            <input type="hidden" name="action" value="'.$action.'">
            '.$after_hidden_fields.'
            
            <div class="submit_group">
               
               <button class="btn button booking_form_submit" data-post-id="'.$post_id.'"><i class="fas fa-shopping-cart"></i> '.__('Book Now', BABE_TEXTDOMAIN).'</button>
               
            </div>
            
            </form>';
            
        /*<button class="btn button booking_form_calculate" data-post-id="'.$post_id.'"><i class="fas fa-calculator"></i>'.__('Calculate', BABE_TEXTDOMAIN).'</button>*/    
            
            $output = apply_filters('babe_booking_form_html', $output, $babe_post, $input_fields, $after_hidden_fields);
              
        } //// end if $booking_obj_post_type 
        
        if ($output){
            $output = '
            <div id="booking_form_block">
            '.$output.'
              
            '.$modal_meeting_points.'
            </div>';
        }      
        
        return $output; 
    }
    
//////////////////////////////////////

        /**
		 * Adds select time field to the search form.
		 * 
		 * @param string $field_name
         * @param string $field_title
         * @param array $values_arr
         * @param string $selected_key
         * @param boolean $required
		 * 
		 * @return string
		 */
		public static function input_select_field( $field_name, $field_title = '', $values_arr = array(), $selected_key = false, $required = false ) {
		  
            $output = '';
            
            if (empty($values_arr)){
                return $output;
            }
            
            if (!isset($values_arr[$selected_key])){
                reset($values_arr);
                $selected_key = key($values_arr);
            }
            
			foreach ($values_arr as $key => $value){
                $add_class = $key === $selected_key ? ' term_item_selected' : '';
                $output .= '<li class="term_item'.$add_class.'" data-id="'.$key.'" data-value="'.$value.'">'.$value.'</li>';
            }
            
            $output = '<ul class="input_select_list">
                '.$output.'
            </ul>';
            
            $add_required = $required ? 'required="required"' : '';
            
            $field_title = $field_title ? '<div class="input_select_title_value">' . $field_title . '</div>' : '';				
			
            $output = '
						<div class="input_select_field input_select_field_'.esc_attr($field_name).'" data-name="'.$field_name.'">
							<div class="input_select_title">
                                ' . $field_title . '
                                <div class="input_select_wrapper">
                                  <input type="text" class="input_select_input" name="'.$field_name.'_label" '.$required.' value="'.(isset($values_arr[$selected_key]) ? $values_arr[$selected_key] : '').'">
                                  <input type="hidden" class="input_select_input_value" name="'.$field_name.'" '.$required.' value="'.$selected_key.'">
                                  ' . $output . '
                                  <i class="fas fa-chevron-down"></i>
                                </div>
                             </div>	
						</div>
					';			
			
			return $output;
		}
        
////////////////////////////
     /**
	 * Get range input select options.
     * 
     * @param int $start
     * @param int $end
     * @param int $step
     * @param int $selected_value
     * 
     * @return string
	 */ 
     public static function get_range_input_select_options($start, $end, $step = 1, $selected_value = ''){
     
        $output = '';
      
        for($i = $start; $i <= $end; $i += $step){
           $add_class = $i === $selected_value ? ' term_item_selected' : '';
           $output .= '<li class="term_item'.$add_class.'" data-id="'.$i.'">'.$i.'</li>';
        }
      
        return $output;
      
     }        
        
////////////////////////////
    /**
	 * Time select array.
     * 
     * @param string $date in d/m/Y or m/d/Y format
     * @param int $post_id
     * @param boolean $start_time is time time_from or time_to
     * @param array $order_item_args
     * @param int $step
     * 
     * @return array
	 */
    public static function get_time_select_arr($date, $post_id, $start_time = true, $order_item_args = array(), $step = 60){

        $output = array();
        
        $date_from = BABE_Calendar_functions::date_to_sql($date);
        
        $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
        $hold = $rules_cat['rules']['basic_booking_period'] == 'day' && $rules_cat['rules']['hold'] ? $rules_cat['rules']['hold'] : 0;
        
        $av_cal = BABE_Calendar_functions::get_av_cal($post_id, $date_from, $date_from, $order_item_args);
        
        //error_log('$av_cal: '.print_r($av_cal, 1));
               
        $date_from_obj = new DateTime($date_from);
        $max_guests = abs(intval(get_post_meta($post_id, 'guests', true )));
        
        if (!empty($av_cal) && isset($av_cal[$date_from_obj->format('Y-m-d')]['times'])){
            
            $av_times_count = count($av_cal[$date_from_obj->format('Y-m-d')]['times']);
            $av_guest = max($av_cal[$date_from_obj->format('Y-m-d')]['times']);
            
            if (($start_time && !$av_guest && $av_times_count%2 == 1 ) || ($start_time && $av_guest && $av_times_count > 1) || (!$start_time && !$av_guest)){
                return $output;
            }
            
            if ($start_time && !$av_guest && $av_times_count%2 == 0){
                
                $max_time = '23:59';
                end($av_cal[$date_from_obj->format('Y-m-d')]['times']);
                $min_time = key($av_cal[$date_from_obj->format('Y-m-d')]['times']);
                
                $min_time_obj = new DateTime('2000-01-01 '.$min_time);
                $max_time_obj = new DateTime('2000-01-01 '.$max_time);
                
                if ($hold){
                    $min_time_obj->modify('+'.$hold.' hours'); 
                }
                
            } elseif (!$start_time && $av_guest && $av_times_count > 1) {
                
                $min_time = '00:00';
                $keys = array_keys($av_cal[$date_from_obj->format('Y-m-d')]['times']);
                $max_time = $keys[1];
                
                $min_time_obj = new DateTime('2000-01-01 '.$min_time);
                $max_time_obj = new DateTime('2000-01-01 '.$max_time);
                if ($hold){
                    $max_time_obj->modify('-'.$hold.' hours'); 
                }
                
            } else {
                
                $min_time = '00:00';
                $max_time = '23:59';
                
                $min_time_obj = new DateTime('2000-01-01 '.$min_time);
                $max_time_obj = new DateTime('2000-01-01 '.$max_time);
            }
            
                        
        
        if ($step <=0 || $step > 30){
            $step = 0;
        }
        
        $step = floor($step/5);
        if ($step == 5) {
            $step = 6;
        }
        
        $min_arr = array(':00');
        
        if ($step){
           for ($i = ($step*5); $i < 60; $i = $i+$step*5){
              $min_arr[] = $i < 10 ?  ':0'.$i : ':'.$i;
           }
        }
        
        for($i=0; $i <= 23; $i++){
            $i_text = $i < 10 ? '0'.$i : $i;
            foreach ($min_arr as $min_text){
                $current_time = $i_text.$min_text;
                $current_time_obj = new DateTime('2000-01-01 '.$current_time);
                if ($current_time_obj >= $min_time_obj && $current_time_obj <= $max_time_obj){
                   $output[$current_time] = $current_time;
                }
            }    
        }
        
        }
    
        return $output;
    }                
    
////////////////////////////
    /**
	 * Add checkout form to page.
     * 
     * @param array $args
     * 
     * @return string
	 */
    public static function admin_order_confirm_page_content($args){

        $output = '';
        
        $args = wp_parse_args( $args, array(
            'order_id' => 0,
            'order_num' => '',
            'order_admin_hash' => '',
            'order_status' => '',
            'current_action' => '',
            'action_update' => '',
            'check_update' => '',
        ));
        
        if ('av_confirmation' != $args['order_status']){
            //// Order is confirmed or rejected
            
            $add_class = $args['order_status'] != 'not_available' ? 'confirm' : 'reject';
            
            $output .= '<h4 class="babe_message_order babe_message_order_'.$add_class.'">';
            
            $output .= $args['order_status'] != 'not_available' ? sprintf(__( 'Order #%s is confirmed.', BABE_TEXTDOMAIN ), $args['order_num']) : sprintf(__( 'Order #%s is rejected.', BABE_TEXTDOMAIN ), $args['order_num']);
            
            $output .= '</h4>';
            
        } else {
            $args['check_update'] = 1;
            
            unset($args['order_status']);
            
            $message = $args['action_update'] == 'confirm' ? __( 'Confirm Order #', BABE_TEXTDOMAIN ) : __( 'Reject Order #', BABE_TEXTDOMAIN );
            
            $message .= $args['order_num'];
            
            $url = BABE_Settings::get_admin_confirmation_page_url($args);
            
            //// Button as url with $message and check_update = 1
            $output .= '<div class="babe_admin_order_confirm">
              <a href="'.$url.'" class="babe_button_admin_order babe_button_admin_order_'.$args['action_update'].'">'.$message.'</a>
            </div>';
        }
        
        return $output; 
    }    
    
////////////////////////////
    /**
	 * Create order items html.
     * @param int $order_id
     * @return string
	 */
    public static function order_items($order_id){
        $output = '';
        
        if (isset(self::$order_items[$order_id])){
            return self::$order_items[$order_id];  
        }

        $ages_arr = BABE_Post_types::get_ages_arr();
        $thumbnail = apply_filters('babe_order_items_img_thumbnail', 'thumbnail');
        
        if ($order_id){
            
            $output .= '<table class="table_order_items_details" cellpadding="0" cellspacing="0"><tbody>';
            
            $order_items_arr = BABE_Order::get_order_items($order_id);
            
            foreach($order_items_arr as $item_id => $item){
                $booking_obj_id = $item['booking_obj_id'];
                $post = BABE_Post_types::get_post($booking_obj_id);
                
                $title = '<a target="_blank" href="'.get_permalink($booking_obj_id).'">'.$item['order_item_name'].'</a>';
                
                $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($booking_obj_id);
                
                $total_item_prices = BABE_Prices::get_obj_total_price($booking_obj_id, $item['meta']['price_arr']);
                
                /// get post thumbnail
                $image_srcs = wp_get_attachment_image_src( get_post_thumbnail_id( $booking_obj_id ), $thumbnail);
                $image = $image_srcs ? '<a target="_blank" href="'.get_permalink($booking_obj_id).'"><img src="'.$image_srcs[0].'"></a>' : '';
                
                
                $output .= '<tr><td class="order_item_row_image">'.$image.'</td>';
                
                $output .= '<td class="order_item_row_details">
                <table class="table_order_item_row_details" cellpadding="0" cellspacing="0"><tbody>
                
                <tr><td class="order_item_info order_item_info_title">
                '.$title.'
                </td></tr>';
                
                /// date from - duration/ date to
                $date_format = $rules_cat['rules']['basic_booking_period'] == 'day' || $rules_cat['rules']['basic_booking_period'] == 'single_custom' ? get_option('date_format').' - '.get_option('time_format') : get_option('date_format');
                                
                $date_from_obj = new DateTime($item['meta']['date_from']);
                $date_from_html = '
                  <span class="order_item_td_value">'.( date_i18n( $date_format, strtotime($date_from_obj->format('Y-m-d H:i')) ) ).'</span>';
                  
                if ($rules_cat['rules']['basic_booking_period'] != 'recurrent_custom'){
                    $date_to_obj = new DateTime($item['meta']['date_to']);
                    $date_from_html = '<span class="order_item_td_label">'.__( 'From:', BABE_TEXTDOMAIN ).'</span>'. $date_from_html . '<span class="order_item_td_label">'.__( 'To:', BABE_TEXTDOMAIN ).'</span>
                  <span class="order_item_td_value">'.( date_i18n( $date_format, strtotime($date_to_obj->format('Y-m-d H:i')) ) ).'</span>';
                } else {
                    $date_from_html = '<span class="order_item_td_label">'.__( 'Date:', BABE_TEXTDOMAIN ).'</span>'. $date_from_html . '<span class="order_item_td_label">'.__( 'Time:', BABE_TEXTDOMAIN ).'</span>
                  <span class="order_item_td_value">'.$date_from_obj->format(get_option('time_format')).'</span>';
                }
                
                $date_from_html = '<tr><td class="order_item_info order_item_info_dates">
                  '.$date_from_html.'
                  </td></tr>';
                
                $output .= apply_filters('babe_order_items_date_from_html', $date_from_html, $post, $rules_cat, $date_from_obj, $item);  
                
                $duration = BABE_Post_types::get_post_duration($post);
                $duration = $duration ? '
                  <tr><td class="order_item_info order_item_info_duration">
                  <span class="order_item_td_label">'.__( 'Duration:', BABE_TEXTDOMAIN ).'</span>
                  <span class="order_item_td_value">'.$duration.'</span>
                  </td></tr>' : '';
                  
                $output .= apply_filters('babe_order_items_duration_html', $duration, $post, $rules_cat);  
                
                /// Departure - meeting point 
                $meeting_points_arr = BABE_Post_types::get_post_meeting_points($post);
                $meeting_point_id = isset($item['meta']['booking_meeting_point']) ? intval($item['meta']['booking_meeting_point']) : '';
                
                if (!empty($meeting_points_arr) && $meeting_point_id && isset($meeting_points_arr[$meeting_point_id])){
                    $mp_html = '
                  <tr><td class="order_item_info order_item_info_meeting_point">
                  <span class="order_item_td_label">'.__( 'Departure from:', BABE_TEXTDOMAIN ).'</span>
                  <span class="order_item_td_value"><a href="'.$meeting_points_arr[$meeting_point_id]['permalink'].'" target="_blank">'.$meeting_points_arr[$meeting_point_id]['address'].'</a></span>
                  </td></tr>';
                  
                  if (isset($meeting_points_arr[$meeting_point_id]['times'][$date_from_obj->format('H:i')])){
                  $date_tmp = new DateTime('2017-01-01 '.$meeting_points_arr[$meeting_point_id]['times'][$date_from_obj->format('H:i')]);
                  $departure_time = $date_tmp->format(get_option('time_format'));
                  
                  $mp_html .= '
                  <tr><td class="order_item_info order_item_info_meeting_point_time">
                  <span class="order_item_td_label">'.__( 'Departure time:', BABE_TEXTDOMAIN ).'</span>
                  <span class="order_item_td_value">'.$departure_time.'</span>
                  </td></tr>';
                  } //// end if $meeting_points_arr[$meeting_point_id]['times'][$date_from_obj->format('H:i')])
                  
                  $output .= apply_filters('babe_order_items_meeting_points', $mp_html, $post, $rules_cat, $item, $total_item_prices);
                  
                  $output = apply_filters('babe_order_items_after_meeting_points', $output, $post, $rules_cat, $item, $total_item_prices);
                  
                } ///// end if !empty($meeting_points_arr)
                
                if (!isset($rules_cat['category_meta']['categories_remove_guests']) || !$rules_cat['category_meta']['categories_remove_guests']){
                /// Prices by age $item['meta']['price_arr']
                $label_guests = $rules_cat['rules']['booking_mode'] == 'tickets' ? __( 'Tickets:', BABE_TEXTDOMAIN ) : __( 'Guests:', BABE_TEXTDOMAIN );
                
                $guests_html = '
                  <tr><td class="order_item_info order_item_info_guests">
                  <span class="order_item_td_label">'.$label_guests.'</span>
                  <span class="order_item_td_value"><table class="order_item_age_prices" cellpadding="0" cellspacing="0"><tbody>';
                  
                  foreach($item['meta']['guests'] as $age_id => $guests_num){
                    
                     if ($guests_num){
                    
                     $age_title = isset($ages_arr[$age_id]) ? $ages_arr[$age_id]['name'] : ( $guests_num > 1 ? __( 'persons,', BABE_TEXTDOMAIN ) : __( 'person,', BABE_TEXTDOMAIN ) );
                     
                     $guests_price = isset($item['meta']['price_arr']['clear_with_taxes'][$age_id]) ? '
                      <td><span class="order_item_age_price">
                      '.BABE_Currency::get_currency_price($item['meta']['price_arr']['clear_with_taxes'][$age_id]).'
                      </span></td>' : '';
                     
                     if (!$age_id){
                        
                        $guests_html .= '
                        <tr>
                          <td class="order_item_age_guests"><span class="order_item_age_guests_num">'.$guests_num.' '.$age_title.'</span></td>
                        '.$guests_price.'
                        </tr>';
                        
                     } else { 
                        
                      $guests_html .= '
                      <tr>
                        <td class="order_item_age_title">'.$age_title.'</td>
                        <td class="order_item_age_guests"><span class="order_item_age_guests_num">x'.$guests_num.'=</span></td>
                      '.$guests_price.'
                      </tr>';
                      
                     }
                     
                    } 
                      
                 } 
                  
                $guests_html .= '</tbody></table>
                  </span>
                </td></tr>';
                
                $output .= apply_filters('babe_order_items_guests', $guests_html, $post, $rules_cat, $item, $total_item_prices);
                
                $output = apply_filters('babe_order_items_after_guests', $output, $post, $rules_cat, $item, $total_item_prices); 
                
                }
                
                $output = apply_filters('babe_order_items_before_services', $output, $post, $rules_cat, $item, $total_item_prices);
                /// Services $item['meta']['price_arr']['services']
                if (!empty($item['meta']['price_arr']['services'])){
                    
                    $label_services = isset($rules_cat['category_meta']['categories_services_title']) ? apply_filters('translate_text', $rules_cat['category_meta']['categories_services_title']).':' : __( 'Services:', BABE_TEXTDOMAIN );
                    
                  $output .= '
                  <tr><td class="order_item_info order_item_info_services">
                  <span class="order_item_td_label">'.$label_services.'</span>
                  <span class="order_item_td_value"><table class="order_item_services" cellpadding="0" cellspacing="0"><tbody>';
                  
                  foreach($item['meta']['price_arr']['services'] as $service_id => $service_prices){
                    $price = 0;
                    $price_details = array();
                    foreach($service_prices['clear_with_taxes'] as $age_id => $age_price){
                        $price += $age_price;
                        $price_details[] = $age_id ? BABE_Currency::get_currency_price($age_price) : '';
                    }
                    $service_title = get_the_title($service_id);
                    $price_details_row = '<td class="order_item_service_price_details">'.implode('+', $price_details).'</td>
                    ';
                    
                    $price_details_row = implode('+', $price_details);
                    $price_details_row = $price_details_row ? ' ('.$price_details_row.')' : '';
                    
                    $output .= '<tr><td class="order_item_service_title">
                    '.$service_title.'
                    </td>
                    <td class="order_item_service_price">
                      '.BABE_Currency::get_currency_price($price).$price_details_row.'
                    </td>
                    </tr>';
                    
                  }
                  
                  $output .= '</tbody></table>
                  </span>
                  </td></tr>';
                  
                  $output = apply_filters('babe_order_items_after_services', $output, $post, $rules_cat, $item, $total_item_prices);  
                }
                
                $output = apply_filters('babe_order_items_after_main_rows', $output, $post, $rules_cat, $item, $total_item_prices);
                
                $output .= '
                </tbody></table>
                
                </td><td class="order_item_row_price">';
                
                /// Total item price                
                $discount_note = $item['meta']['price_arr']['discount'] ? '<tr><td class="order_item_discount_note">'.sprintf(__( 'Price Cut %d%% off applied', BABE_TEXTDOMAIN ), $item['meta']['price_arr']['discount']).'</td></tr>' : '';
                
                $output .= '
                <table class="table_order_item_total_price"><tbody>
                <tr><td class="order_item_total_price">'.BABE_Currency::get_currency_price($total_item_prices['total_with_taxes']).'
                </td></tr>
                '.$discount_note.'
                </tbody></table>
                </td></tr>';
                
               // $output .= '$item: ' . print_r($item, 1);
               // $output .= '$rules_cat: ' . print_r($rules_cat, 1);
                
            } /// end foreach $order_items_arr
            
            /// Total price
            $total_price = BABE_Order::get_order_total_amount($order_id);
            
            $prepaid_received = BABE_Order::get_order_prepaid_received($order_id) - BABE_Order::get_order_refunded_amount($order_id);
            
            $output .= '<tr><td class="order_items_row_total" colspan="3">
            <span class="order_items_row_total_label">
            '.__( 'Total amount:', BABE_TEXTDOMAIN ).'
            </span>
            <span id="order_items_row_total_amount">
            '.BABE_Currency::get_currency_price($total_price).'
            </span>
            </td></tr>
            <tr><td class="order_items_row_total order_items_row_paid" colspan="3">
            <span class="order_items_row_total_label">
            '.__( 'Paid:', BABE_TEXTDOMAIN ).'
            </span>
            <span id="order_items_row_paid_amount">
            '.BABE_Currency::get_currency_price($prepaid_received).'
            </span>
            </td></tr>';
            
            $output .= '</tbody></table>';
            
            $output = apply_filters('babe_order_items_html', $output, $order_id, $order_items_arr, $ages_arr);            
            
        } //// end if $order_id
        
        self::$order_items[$order_id] = $output;
        
        return $output;
    }
    
///////////////////////////////////////    
    /**
	 * Ajax apply coupon to order
	 */
    public static function ajax_apply_coupon_to_order(){
        
        $output = 0;
        
        if (isset($_POST['nonce']) && wp_verify_nonce( $_POST['nonce'], self::$nonce_title ) && BABE_Coupons::coupons_active()){
           $args = wp_parse_args( $_POST, array(
            'order_id' => 0,
            'order_num' => '',
            'order_hash' => '',
            'coupon_num' => '',
           ));
           $order_id = absint($args['order_id']);
           $coupon_num = sanitize_text_field($args['coupon_num']);
           
           if (BABE_Order::is_order_valid($order_id, $args['order_num'], $args['order_hash'])){
               $output = BABE_Coupons::update_order_amount($order_id, $coupon_num);
           }  
        }
        
        echo $output;
        wp_die();                   
    }
    
////////////////$output, $order_id, $order_items_arr, $ages_arr    
     /**
	 * Output coupon field html with order items
     * 
     * @param string $content
     * @param int $order_id
     * @param array $order_items_arr
     * @param array $ages_arr
     * @return string
	 */
     public static function coupon_field_to_order_items($content, $order_id, $order_items_arr, $ages_arr){
        
        $output = $content;
        
        if (BABE_Coupons::coupons_active()){
        
        $coupon = BABE_Coupons::get_coupon_by_order_id($order_id);
        if ($coupon){
            //// render info block about applied coupon
            $coupon_num = BABE_Coupons::get_coupon_num($coupon->ID);
            $coupon_amount = BABE_Coupons::get_coupon_amount($coupon->ID);
            
            $output .= '
            <div class="coupon-form-block-applied">
                '.sprintf(__( 'Coupon Code %s with amount %s was applied', BABE_TEXTDOMAIN ), $coupon_num, BABE_Currency::get_currency_price($coupon_amount)).'
            </div>';
        }
        
        }
        
        return $output;
    }
        
////////////////////////
     /**
	 * Output coupon field html with the checkout form
     * 
     * @param string $content
     * @param array $args
     * @return string
	 */
     public static function coupon_field_to_checkout_form($content, $args){
        
        $output = $content;
        $order_id = $args['order_id'];
        
        if (BABE_Coupons::coupons_active()){
        
        $coupon = BABE_Coupons::get_coupon_by_order_id($order_id);
        if (!$coupon){
            //// render input field with button Apply
            $output .= '
            <div class="coupon-form-block">
                <label class="coupon_form_input_label">'.__( 'Enter Coupon Code and get a discount!', BABE_TEXTDOMAIN ).'</label>
            <span class="coupon_form_input_field">
				   <input type="text" name="coupon_number" id="coupon_input_field" value="" placeholder="'.'" />
			</span>
            <span id="coupon_form_submit_loader"></span>
            <span id="coupon_form_submit" class="btn button button-primary">'.__( 'Apply Coupon', BABE_TEXTDOMAIN ).'</span>
            </div>';
            
        }
        
        }
        
        return $output;
    }    
    
////////////////////////////
    /**
	 * Create order customer details html.
     * @param int $order_id
     * @return string
	 */
    public static function order_customer_details($order_id){
        $output = '';
        
        if (isset(self::$order_customer_details[$order_id])){
            return self::$order_customer_details[$order_id];  
        }

        $order_meta = BABE_Order::get_order_customer_details($order_id);
        
        unset($order_meta['email_check']);
        
        $order_meta = apply_filters('babe_order_customer_details_fields', $order_meta, $order_id);
        
        $output .= '<table class="table_customer_details" cellpadding="0" cellspacing="0"><tbody>';
            
        foreach($order_meta as $field_name => $field_content){
            $output .= '
            <tr>
            <td class="customer_field_label">'.self::checkout_field_label($field_name).'</td>
            <td class="customer_field_content">'.$field_content.'</td>
            </tr>
            ';
        }
        
        $output .= '</tbody></table>';
        
        $output = apply_filters('babe_order_customer_details_html', $output, $order_id);
        
        self::$order_customer_details[$order_id] = $output;
        
        return $output;
    }            
    
////////checkout_field_required///
    /**
	 * Required tag for checkout fields.
     * @param string $required_tag
     * @param string $field_name
     * @return string
	 */
    public static function checkout_field_required($required_tag, $field_name){
        $output = $required_tag;
        $required_tag_string = 'required="required"';
        
        switch($field_name){
            case 'first_name':
            case 'last_name':
            case 'email':
            case 'email_check':
            case 'phone':
              $output = $required_tag_string;
              break;  
        }
        
        return $output;
    }        
    
////////checkout_field_label///
    /**
	 * Labels for checkout fields.
     * @param string $label
     * @param string $field_name
     * @return string
	 */
    public static function checkout_field_label($field_name){
        $output = '';
        
        switch($field_name){
            case 'first_name':
              $output = __('First name', BABE_TEXTDOMAIN);
              break;
            case 'last_name':
              $output = __('Last name', BABE_TEXTDOMAIN);
              break;
            case 'email':
              $output = __('Email', BABE_TEXTDOMAIN);
              break;
            case 'email_check':
              $output = __('Re-type Email', BABE_TEXTDOMAIN);
              break;
            case 'phone':
              $output = __('Contact Phone', BABE_TEXTDOMAIN);
              break;  
        }
        
        $output = apply_filters('babe_checkout_field_label', $output, $field_name);
        
        return $output;
    }    
    
////////////////////////////
    /**
	 * Add checkout form to page.
     * @param array $args
     * @return string
	 */
    public static function checkout_form($args){

        $output = '';
        $input_fields = array();
        
        $args = wp_parse_args( $args, array(
            'order_id' => 0,
            'order_num' => '',
            'order_hash' => '',
            'total_amount' => 0,
            'prepaid_amount' => 0,
            'payment_model' => 'full',
            'order_currency' => '',
            'action' => 'to_pay', //to_pay or to_av_confirm
            'meta' => array(),
        ));
        
        $args['meta'] = wp_parse_args( $args['meta'], array(
            'first_name' => '',
            'last_name' => '',
            'email' => '',
            'email_check' => '',
            'phone' => '',
        ));
        
        $order_id = $args['order_id'];
        $order_num = $args['order_num'];
        $order_hash = $args['order_hash'];
        $action = $args['action'];
        $total_amount = $args['total_amount'];
        $prepaid_amount = $args['prepaid_amount'];
        
        $payment_model = $args['payment_model'];
        $order_currency = $args['order_currency'] ? $args['order_currency'] : BABE_Currency::get_currency();
        
        $args['meta'] = apply_filters('babe_chekout_args', $args['meta'], $args);
        
        $output .= '<h2>'.sprintf(__('Order #%s', BABE_TEXTDOMAIN), $order_num).'</h2>';
        
        $output .= self::order_items($order_id);
        
        $output = apply_filters('babe_chekout_after_order_items', $output, $args);
            
            ///////// fields
            
            foreach($args['meta'] as $field_name => $field_content){
                
            $add_content_class = $field_content ? 'checkout_form_input_field_content' : '';    
         
            $input_fields[] = '
            <div class="checkout-form-block">
                
               <div class="checkout_form_input_field '.$add_content_class.'">
                   <label class="checkout_form_input_label">'.self::checkout_field_label($field_name).'</label>
				   <input type="text" class="checkout_input_field checkout_input_required" name="'.$field_name.'" id="'.$field_name.'" value="'.$field_content.'" '.apply_filters('babe_checkout_field_required', '', $field_name).'/>
                   <div class="checkout_form_input_underline"><span class="checkout_form_input_ripple"></span></div>
			   </div>
               
            </div>';
            
            }
            
            //////////////////////////////////
            
        $input_fields = apply_filters('babe_chekout_input_fields_arr', $input_fields, $args);    
            
            //////////////////////////////////
            $payment_fields = '';
            if($action == 'to_pay'){
                
                $payment_fields = '<div class="amount_group"> 
                <label class="checkout_form_amount_label">'.__('Amount to Pay now:', BABE_TEXTDOMAIN).'</label>
                <div class="checkout_form_pay_total">
                <input type="radio" name="payment[amount_to_pay]" id="order_amount_to_pay_deposit" value="deposit" checked="checked"><label for="order_amount_to_pay_deposit">'.BABE_Currency::get_currency_price($prepaid_amount).' '.($payment_model == 'deposit_full' ? __('(deposit)', BABE_TEXTDOMAIN) : '').'</label>
                </div>
                '.($payment_model == 'deposit_full' ? '
                <div class="checkout_form_pay_total">
                <input type="radio" name="payment[amount_to_pay]" id="order_amount_to_pay_full" value="full"><label for="order_amount_to_pay_full">'.BABE_Currency::get_currency_price($total_amount).' '.__('(full)', BABE_TEXTDOMAIN).'</label>
                </div>
                ' : '').'
            </div>';
                
                
                
                $payment_methods_arr = BABE_Settings::get_active_payment_methods();
                 
                 $payment_titles = '';
                 $payment_details = '';
                 $input_fields_name = 'payment';
                 $first_method = '';
                 $i = 0;
                foreach($payment_methods_arr as $method => $method_title){
                 //// input names like payment[...]
                 $tab_start_active = !$i ? ' tab_active' : '';
                 $first_method = !$i ? $method : $first_method;
                 
                 $payment_titles .= '<span class="payment_method_title payment_method_title_'.$method.' tab_title'.$tab_start_active.'" data-method="'.$method.'">'.apply_filters('babe_checkout_payment_title_'.$method, $method_title, $args, $input_fields_name).'</span>';
                 $payment_details .= '<div class="payment_method_fields payment_method_fields_'.$method.' tab_content'.$tab_start_active.'" data-method="'.$method.'">'.apply_filters('babe_checkout_payment_fields_'.$method, '', $args, $input_fields_name).'</div>';
                 $i++;
                }
                
                $payment_fields .= '<h2>'.__('Payment Method', BABE_TEXTDOMAIN).'</h2>
                <div class="payment_group tabs_group">
                <div class="payment_titles_group tabs_titles">
                '.$payment_titles.'
                </div>
                <div class="payment_fields_group">'
                .$payment_details.'
                 </div>
                 <input type="hidden" name="payment[payment_method]" value="'.$first_method.'">
                 </div>
                 ';
                                 
            } else {
                
                $payment_details_text = sprintf(__('You could pay after the items availability confirmation! <br> Confirmation will be sent to your e-mail. <br> Amount to pay online will be %s.', BABE_TEXTDOMAIN), BABE_Currency::get_currency_price($prepaid_amount));
                $payment_details_text = apply_filters('babe_chekout_payment_details_before_av_check', $payment_details_text, BABE_Currency::get_currency_price($prepaid_amount), $args);
                
                $payment_fields .= '<h2>'.__('Payment details', BABE_TEXTDOMAIN).'</h2>
                 <div class="payment_group payment_details_before_av_check">
                 '.$payment_details_text.'
                 </div>
                 ';
                
            }  ///// if $action
            
            $output .= '<h2>'.__('Contact information', BABE_TEXTDOMAIN).'</h2>';
            
            $output .= '<form id="checkout_form" name="checkout_form" method="post" action="">
            
            '.apply_filters('babe_checkout_before_contact_fields', '', $args).'
            
            <div class="contact_fields_group input_group">
            
            '.implode('', $input_fields).'
            
            </div>
            
            '.apply_filters('babe_checkout_after_contact_fields', '', $args).'

            <input type="hidden" name="order_id" value="'.$order_id.'">
            <input type="hidden" name="order_num" value="'.$order_num.'">
            <input type="hidden" name="order_hash" value="'.$order_hash.'">
            <input type="hidden" name="action" value="'.$action.'">
            
            '.$payment_fields.'
            
            '.apply_filters('babe_checkout_after_payment_fields', '', $args). apply_filters('babe_checkout_terms_fields', '
            <div class="terms_group">
              <div class="checkout_form_terms_check">
              <input type="checkbox" name="payment[terms_check]" id="order_terms_check" value="agree" required="required"><label for="order_terms_check">'.__('I read and agree to the terms & conditions', BABE_TEXTDOMAIN).'</label>
              </div>
              <div class="checkout_form_terms_details">
              '.BABE_Settings::get_terms_page_content().'
              </div>
            </div>
            ', $args) . apply_filters('babe_checkout_after_terms_fields', '', $args).'
            
            <div class="submit_group">
               
               <button class="btn button checkout_form_submit">'.__('Complete My Order', BABE_TEXTDOMAIN).'</button>
               
            </div>
            
            </form>';
            
            $output = apply_filters('babe_chekout_form_html', $output, $args);

        
        if ($output){
            $output = '
            <div id="checkout_form_block">
            '.$output.'
            </div>';
        }      
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Add confirm content to page.
     * @param array $args
     * @return string
	 */
    public static function confirm_content($args){

        $output = '';
        
        $args = wp_parse_args( $args, array(
            'order_id' => 0,
            'order_num' => '',
            'order_hash' => '',
            'order_status' => '',
        ));
        
        $order_id = $args['order_id'];
        
        ///// messages for $args['order_status']
        if ($args['order_status'] && isset(BABE_Settings::$settings['message_'.$args['order_status']])){
          
            $output .= '
            <div class="babe_message_order babe_message_order_status_'.$args['order_status'].'">
               ' . BABE_Settings::$settings['message_'.$args['order_status']] . '
            </div>';
            
        }
        
        if ($args['order_status'] == 'payment_expected'){
            $output .= '<div class="babe_order_confirm">
              <a href="'.BABE_Order::get_order_payment_page($order_id).'" class="babe_button_order babe_button_order_to_pay">'.__('Pay Now!', BABE_TEXTDOMAIN).'</a>
            </div>';
        }
        
        $output .= '<h4>'.sprintf(__('Order #%s', BABE_TEXTDOMAIN), $args['order_num']).'</h4>';
        
        $output .= self::order_items($order_id);
        
        $output .= self::order_customer_details($order_id);
        
        $output = apply_filters('babe_confirm_content_html', $output, $args);
        
        return $output; 
    }            
    
////////////////////////////
    /**
	 * Add calendar to booking_obj page.
     * @param array $post
     * @return string
	 */
    public static function block_calendar($post){

        $output = '';
        $post_id = isset($post['ID']) ? intval($post['ID']) : 0;
        
        if ($post_id){
            
         $av_cal = BABE_Calendar_functions::get_av_cal($post_id);
         
         if (!empty($av_cal)){
            
            $date_now_obj = BABE_Functions::datetime_local();
            
            $date_from = $date_now_obj->format("Y-m-d");
            $date_to = date("Y-m-d", strtotime("+1 year +1 month"));
            
            ///// get rules
            $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post_id);
            
            ///// get rates
            $rates = BABE_Prices::get_rates($post_id, $date_from, $date_to);
            
            //// get discount
            $discount_arr = BABE_Post_types::get_post_discount($post_id);

            ///// create calendar by month
            $date_current = $date_now_obj->format('Y-m-01');
            $date_obj_current = new DateTime($date_current);
            $date_end = clone($date_obj_current);
            $date_end->modify('+1 year');
            $interval = new DateInterval('P1M');
            $daterange = new DatePeriod($date_obj_current, $interval ,$date_end);
            $month_html = '';
            $i = 0;
            foreach($daterange as $date_obj){
                $block_class = !$i ? 'cal-month-active' : '';
                $month_html .= self::get_calendar_month_html($date_obj->format('Y-m-01'), $av_cal, $rates, $discount_arr, $rules_cat, $block_class);
                $i++;
            }
            
            
            $output .= $month_html ? '<div id="av-cal">'.$month_html.'</div>' : '';
           } 
   
        } //// end if $post_id    
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Get calendar month html.
     * @param string $date - format Y-m-d
     * @param array $av_cal
     * @param array $rates
     * @param array $discount_arr
     * @param array $rules_cat - rules with category meta
     * @param string $block_class
     * @return string
	 */
    public static function get_calendar_month_html($date, $av_cal, $rates, $discount_arr, $rules_cat, $block_class = ''){

        $output = '';
        
        $price_types = BABE_Prices::get_price_types_from_rule($rules_cat['rules']);
        krsort($price_types, SORT_STRING);
        $main_age_id = BABE_Post_types::get_main_age_id($rules_cat['rules']);
        $ages = BABE_Post_types::get_ages_arr();
        $days_arr = BABE_Calendar_functions::get_week_days_arr();
        $multiplier = (100 - $discount_arr['discount'])/100;
        $tax_am = isset($rules_cat['category_meta']['categories_add_taxes']) && $rules_cat['category_meta']['categories_add_taxes'] && isset($rules_cat['category_meta']['categories_tax']) ? floatval($rules_cat['category_meta']['categories_tax'])/100 : 0;

            ///// create calendar by month
            $date_obj_default = new DateTime($date);
            
            $date_now_obj = BABE_Functions::datetime_local();
            
            $date_current = $date_now_obj->format('Y-m-d');
            
            $date_obj_current = new DateTime($date_current);
           // $date_selected = $date_obj_default->format('Y-m-d');
            $interval = new DateInterval('P1D');
            $date_obj_month_start = new DateTime($date_obj_default->format('Y-m-01'));
            $date_start = clone($date_obj_month_start);
            $date_end = clone($date_obj_month_start);
            
            if (BABE_Calendar_functions::$week_first_day != BABE_Calendar_functions::get_week_day_num($date_start)){
                $start_day_shift = BABE_Calendar_functions::get_week_day_num($date_start) - BABE_Calendar_functions::$week_first_day;
                $date_start->modify('-'.$start_day_shift.' days');
            }
            
            $date_end->modify('+1 month'); // last day will excluded in loop
            
            if (BABE_Calendar_functions::$week_first_day != BABE_Calendar_functions::get_week_day_num($date_end)){
                $end_day_shift = BABE_Calendar_functions::$week_last_day - BABE_Calendar_functions::get_week_day_num($date_end) + 1;
                $date_end->modify('+'.$end_day_shift.' days'); 
            }
            
            $daterange = new DatePeriod($date_start, $interval ,$date_end);
            $i = 0;
            $prev_date_obj = clone($date_start);
            
            foreach($daterange as $date_cal){ //// loop by date
                
                $date_cal_day_num = BABE_Calendar_functions::get_week_day_num($date_cal);
                ///////////////////////
                $add_cell_class = $date_cal->format('m') != $date_obj_month_start->format('m') ? ' cal-cell-empty' : '';
                $av_times_count = isset($av_cal[$date_cal->format('Y-m-d')]['times']) ? count($av_cal[$date_cal->format('Y-m-d')]['times']) : 0;
                $av_guest = 0;
                if ($av_times_count){
                    $av_guest = max($av_cal[$date_cal->format('Y-m-d')]['times']);
                }
                
                $prev_av_times_count = isset($av_cal[$prev_date_obj->format('Y-m-d')]['times']) ? count($av_cal[$prev_date_obj->format('Y-m-d')]['times']) : 0;
                $prev_av_guest = 0;
                if ($prev_av_times_count){
                    $prev_av_guest = max($av_cal[$prev_date_obj->format('Y-m-d')]['times']);
                }
                
                if (($rules_cat['rules']['basic_booking_period'] == 'night' && !$av_guest && $prev_av_guest) || ($rules_cat['rules']['basic_booking_period'] == 'day' && $av_guest && ($av_times_count%2 == 0))){
                    
                    $add_cell_class .= ' cal-cell-disabled-first';
                     
                } elseif (!$av_guest && ($rules_cat['rules']['basic_booking_period'] != 'day' || ($rules_cat['rules']['basic_booking_period'] == 'day' && ($av_times_count%2 == 1 || !$av_times_count)))) { 
                    
                    $add_cell_class .= ' cal-cell-disabled';
                    
                }
                
                if (($rules_cat['rules']['basic_booking_period'] == 'night' && $av_guest && !$prev_av_guest) || ($rules_cat['rules']['basic_booking_period'] == 'day' && !$av_guest && $av_times_count && ($av_times_count%2 == 0))){
                    $add_cell_class .= ' cal-cell-disabled-last';
                }
                                
                /*
                if ($rules_cat['rules']['basic_booking_period'] == 'night' && (!isset($av_cal[$date_cal->format('Y-m-d')]) || !$av_cal[$date_cal->format('Y-m-d')]['times']['00:00']) && isset($av_cal[$prev_date_obj->format('Y-m-d')]) && $av_cal[$prev_date_obj->format('Y-m-d')]['times']['00:00']){
                    $add_cell_class .= ' cal-cell-disabled-first';
                } elseif (!isset($av_cal[$date_cal->format('Y-m-d')]) || !$av_cal[$date_cal->format('Y-m-d')]['times']['00:00']){
                    $add_cell_class .= ' cal-cell-disabled';
                }
                
                if ($rules_cat['rules']['basic_booking_period'] == 'night' && isset($av_cal[$date_cal->format('Y-m-d')]) && $av_cal[$date_cal->format('Y-m-d')]['times']['00:00'] && (!isset($av_cal[$prev_date_obj->format('Y-m-d')]) || !$av_cal[$prev_date_obj->format('Y-m-d')]['times']['00:00'])){
                    $add_cell_class .= ' cal-cell-disabled-last';
                }
                */
                
                if ($date_obj_current > $date_cal || (!$av_guest && ($rules_cat['rules']['basic_booking_period'] != 'day' || ($rules_cat['rules']['basic_booking_period'] == 'day' && ($av_times_count%2 == 1 || !$av_times_count))))){
                    
                    $output .= '<div class="cal-cell'.$add_cell_class.'" data-day="'.$date_cal->format('d').'" data-month="'.$date_cal->format('m').'" data-year="'.$date_cal->format('Y').'" data-date="'.$date_cal->format(BABE_Settings::$settings['date_format']).'" data-date-sql="'.$date_cal->format('Y-m-d').'">
                    <div class="cal-cell-date">'.$date_cal->format('j').'</div>
                    </div>';
                    
                } else {
                    
                    //// get time lines
                    //// get price from
                    $price_from = 0;
                    $rate_current['rate_type'] = '';
                    foreach($rates as $rate){
                        $rate_date_from = $rate['date_from'] ? new DateTime($rate['date_from']) : BABE_Functions::datetime_local();
                        $rate_date_to = $rate['date_to'] ? new DateTime($rate['date_to']) : BABE_Functions::datetime_local();
                        
                       if ($rate['rate_type'] == 'base' || $rate['rate_type'] == 'seasonal'){
                          $price_types_tmp = $price_types;
                       } else {
                          $price_types_tmp['base'] = __('Flat rate', BABE_TEXTDOMAIN);
                       }
                       
                       $price_from = 0;
                        
                        if ($rate['rate_type'] == 'base' || ($rate['rate_type'] == 'seasonal' && $rate_date_from <= $date_cal && $rate_date_to >= $date_cal) || ($rate['rate_type'] == 'event' && $rate_date_from <= $date_cal && (($rate_date_to >= $date_cal && $rules_cat['rules']['basic_booking_period'] == 'day') || ($rate_date_to > $date_cal && $rules_cat['rules']['basic_booking_period'] == 'night')))){
                            
                            foreach ($price_types_tmp as $price_type=>$price_title){
                            
                              if($price_type != 'monthly' && isset($rate[$price_type.'_from'][$main_age_id]) && (($price_type != 'weekend') || ($price_type == 'weekend' && in_array($date_cal_day_num, $rate['weekend_days'] )))){
                                $price_from = !$price_from ? $rate[$price_type.'_from'][$main_age_id] : $price_from; // setup $price_from
                                $rate_current = $rate;                                
                                break; // we found $price_from on actual price type        
                              } 
                            } 

                            break; // we found $price_from on actual rate
                        }
                    }   
                    
                    $price_from = $price_from*$multiplier;                    
                    $price_from = $price_from + round($price_from * $tax_am, 2); 
                    
                    //// get prices table from $rate_current
                    if ($rate_current['rate_type'] == 'base' || $rate_current['rate_type'] == 'seasonal'){
                          $price_types_tmp = $price_types;
                       } else {
                          $price_types_tmp['base'] = __('Flat rate', BABE_TEXTDOMAIN);
                       }  
                       
                       $prices_table = '<div class="view-rate-details">';
                       
                       foreach ($price_types_tmp as $price_type=>$price_title){
                            
                            if(isset($rate_current[$price_type]) && !empty($rate_current[$price_type])){
                                
                            $price_title = $price_type == 'weekly' ? $price_title.' '.__('(for 7 nights)', BABE_TEXTDOMAIN) : $price_title;
                            
                            if ($price_type == 'weekend'){
                                if ($rules_cat['rules']['basic_booking_period'] == 'night'){
                                    $price_title = __('Weekend night', BABE_TEXTDOMAIN);
                                } elseif ($rules_cat['rules']['basic_booking_period'] == 'day'){
                                    $price_title = __('Weekend day', BABE_TEXTDOMAIN);
                                }  
                            }
                            
                            //// get price block
                            $prices_table .= '<div class="view-rate-details-item view-rate-details-item-'.$price_type.'">
                            
                            <h4>'.$price_title.'</h4>';
                            
                            if ($price_type == 'weekend'){
                                $weekend_days = maybe_unserialize($rate_current['weekend_days']);
                                $tmp_days = array();
                                foreach ($weekend_days as $key => $day_num){
                                    $tmp_days[] = $days_arr[$day_num];
                                }
                                $prices_table .= '<div class="rate_weekend_days">'.implode(', ', $tmp_days).'</div>';  
                            }
                            $prices_table .= '<table class="age-prices">
                            <tbody>';
                            
                            if (isset($rate_current[$price_type])){
                              $prices = $rate_current[$price_type];
                            
                              foreach($prices as $age_id => $price){
                                
                                if ( !$rules_cat['rules']['ages'] && !$age_id || $rules_cat['rules']['ages'] && $age_id ){
                                
                                $age_title = !$age_id || !isset($ages[$age_id]) ? __('Price', BABE_TEXTDOMAIN) : $ages[$age_id]['name'] . ' (' . $ages[$age_id]['description'] . ')';
                                $price = round($price*$multiplier, 2);
                                $price = $price + round($price * $tax_am, 2);
                                
                                $prices_table .= '<tr><td><span class="age_title">'. $age_title . '</span></td><td><div class="view-age-price">'.BABE_Currency::get_currency_price($price).'</div></td></tr>';
                                }
                              }
                            }
                            
                            $prices_table .= '</tbody>
                            </table>
                            </div>'; // end view-rate-details-item
                            } //// end if
  
                          } ///  end foreach
                          
                          $prices_table .= '
                            </div>'; // end view-rate-details
                       
                    ////////////// make output   
                    
                    $output .= '<div class="cal-cell cal-cell-active'.$add_cell_class.'" data-day="'.$date_cal->format('d').'" data-month="'.$date_cal->format('m').'" data-year="'.$date_cal->format('Y').'" data-date="'.$date_cal->format(BABE_Settings::$settings['date_format']).'" data-date-sql="'.$date_cal->format('Y-m-d').'">
                    <div class="cal-cell-date">'.$date_cal->format('j').'</div>
                    <div class="cal-cell-pricefrom">'.BABE_Currency::get_currency_price($price_from).'</div>
                    '.$prices_table.'
                    </div>';                 
                        
                }
                $i++;
                $prev_date_obj = $date_cal;
                ///////////////////////
            }
            
            if ($output){
                
                $week_names = BABE_Calendar_functions::get_week_days_arr();
                $week_names_html = '';
                foreach($week_names as $week_name){
                    $week_names_html .= '<div class="cal-week-name">'.$week_name.'</div>';
                }
                
                $add_invisible_cell = $i == 35 ? '<div class="cal-cell cal-cell-invisible"></div>' : ($i == 28 ? '<div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div><div class="cal-cell cal-cell-invisible"></div>' : '');
                
                $output = '
                <div class="cal-month-block '.$block_class.'" data-yearmonth="'.$date_obj_month_start->format('Y-m').'">
                <div class="cal-week-names">'.$week_names_html.'
                </div>
                <div class="cal-month-bar"><span class="cal-month-prev"><i class="fas fa-chevron-left" aria-hidden="true"></i></span>'.BABE_Calendar_functions::$months_names[$date_obj_month_start->format('F')].$date_obj_month_start->format(' Y').'<span class="cal-month-next"><i class="fas fa-chevron-right" aria-hidden="true"></i></span>
                </div>
                <div class="cal-dates-block">
                '.$output.$add_invisible_cell.'
                </div>
                </div>
                ';
                
            }    
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Get services list with checkboxes.
     * 
     * @param array $post - BABE post
     * @param array $selected_services_arr
     * 
     * @return string
	 */
    public static function list_add_services($post, $selected_services_arr = array()){

        $output = '';
        $results = array();
        
        if (!empty($post) && isset($post['services']) && !empty($post['services'])){
            
             $services_arr = BABE_Post_types::get_post_services($post);
             
             if (!empty($services_arr)){
                
                $selected_ids = array_flip($selected_services_arr);
                
                $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post['ID']);
                
                $tax_am = isset($rules_cat['category_meta']['categories_add_taxes']) && $rules_cat['category_meta']['categories_add_taxes'] && isset($rules_cat['category_meta']['categories_tax']) ? floatval($rules_cat['category_meta']['categories_tax'])/100 : 0;
        // $tax = 1 + $tax_am;
                
                $post_ages = BABE_Post_types::get_post_ages($post['ID']);
                
                $ages = !$rules_cat['rules']['ages'] || empty($post_ages) ? array(0 => array('name' => __( 'Price', BABE_TEXTDOMAIN ), 'description' => '')) : $post_ages;
                
                $i = 0;
                $before_service_type = '';
                
                foreach($services_arr as $service){

                    $sr_block = '';
                    
                    $general_price = floatval($service['prices'][0]);
                    
                    $is_other_prices = false;
                    
                    $other_prices = $service['prices'];
                    
                    unset($other_prices[0]);
                    
                    if (empty($other_prices) && !$general_price){
                        continue;
                    }
                    
                    if ($before_service_type != $service['service_type']){                        
                        $before_service_type = $service['service_type'];
                    }
                    
                    $is_percent = $before_service_type == 'booking' && $service['price_type'] == 'percent' ? true : false;
                    
                    $checked = isset($selected_ids[$service['ID']]) ? ' checked="checked"' : '';                    
                    
                    $sr_block .= '<div class="list_service">
                    <div class="list_service_title">
                    <label>
                      <input type="checkbox" name="booking_services[]" value="'.$service['ID'].'" '.$checked.'/>
                      '.__( 'Add ', BABE_TEXTDOMAIN ).'
                    </label>
                    <h4>'.$service['post_title'].'</h4>
                    </div>
                    <div class="list_service_prices">
                    ';
                    
                    if ($rules_cat['rules']['ages'] && is_array($other_prices)){
                      foreach ($other_prices as $test_age => $test_price){
                        $is_other_prices = $test_price !== '' ? true : $is_other_prices; 
                      }
                    }  
                    
                    if (!in_array($before_service_type, array('booking', 'day', 'night'))){
                 
                     foreach($ages as $age_id => $age){
                        
                        if (!$is_percent){
                            
                          $price_value = $is_other_prices ? ( isset($other_prices[$age_id]) && $other_prices[$age_id] !== '' ? floatval($other_prices[$age_id]) : '' ) : $general_price;
                          
                          if ($price_value !== ''){
                            
                             $price_value_html = $price_value == 0 ? __( 'included', BABE_TEXTDOMAIN ) : BABE_Currency::get_currency_price($price_value + round($price_value * $tax_am, 2));
                             
                             $price_label = $is_other_prices ? '<label>'.apply_filters('translate_text', $age['name']).':</label>' : '';
                             
                             $sr_block .= '<span class="service_price_line">'.$price_label.$price_value_html.'</span>';
                            
                          }
                          
                        } else {
                          $sr_block .= $is_other_prices ? (isset($other_prices[$age_id]) && $other_prices[$age_id] !== ''? '<span class="service_price_line"><label>'.apply_filters('translate_text', $age['name']).':</label>'.$other_prices[$age_id].' '.__( '%/booking ', BABE_TEXTDOMAIN ).'</span>' : '') : '<span class="service_price_line"><label>'.apply_filters('translate_text', $age['name']).':</label>'.$general_price.' '.__( '%/booking ', BABE_TEXTDOMAIN ).'</span>';  
                        }
                        
                     }
                     
                     } else {
                        $sr_block .= '<span class="service_price_line">';
                        
                        if (!$is_percent){
                            
                          $price_value_html = $general_price == 0 ? __( 'included', BABE_TEXTDOMAIN ) : BABE_Currency::get_currency_price($general_price + round($general_price * $tax_am, 2));  
                            
                          $sr_block .= $price_value_html;
                          
                        } else {
                          
                          $sr_block .= $general_price.' '.__( '%/booking ', BABE_TEXTDOMAIN );  
                        
                        }
                        
                        $sr_block .= '</span>';
                     }
                     
                     $service_content = $service['post_content'] ? '<div class="view-list-details">'. apply_filters( 'the_content', $service['post_content']).'</div>' : ''; 
                 
                     $sr_block .= '</div>'.$service_content.'
                     </div>';   
                    
                     $results[] = apply_filters('babe_list_add_services_block_html', $sr_block, $service, $ages);
                }
                
                if(!empty($results)){                    
                
                $output .= '
              <div id="list_services">
                '.implode('', $results).'
              </div>
              ';
                 }
                
             }   
        } //// end if !empty($post['services'])    
        
        return $output; 
    }              
    
////////////////////////////
    /**
	 * Add services to booking_obj page.
     * @param array $post
     * @return string
	 */
    public static function block_add_services($post){

        $output = '';
        $results = array();
        
        if (!empty($post) && isset($post['services']) && !empty($post['services'])){
            
             $services_arr = BABE_Post_types::get_post_services($post);
             
             if (!empty($services_arr)){
                
                $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post['ID']);
                
                $tax_am = isset($rules_cat['category_meta']['categories_add_taxes']) && $rules_cat['category_meta']['categories_add_taxes'] && isset($rules_cat['category_meta']['categories_tax']) ? floatval($rules_cat['category_meta']['categories_tax'])/100 : 0;
        // $tax = 1 + $tax_am;
                
                $ages = BABE_Post_types::get_ages_arr();
                
                $ages = empty($ages) ? array(0 => array('name' => __( 'Price', BABE_TEXTDOMAIN ), 'description' => '')) : $ages;
                
                $i = 0;
                $before_service_type = '';
                
                foreach($services_arr as $service){

                    $sr_block = '';
                    
                    if ($before_service_type != $service['service_type']){
                        $sr_block .= '<div class="block_service">
                        <h4 class="block_service_header">
                        '.__( 'Prices ', BABE_TEXTDOMAIN ).BABE_Post_types::$service_type_names[$service['service_type']].'
                        </h4>
                        </div>';
                        
                        $before_service_type = $service['service_type'];
                    }
                    
                    $is_percent = $before_service_type == 'booking' && $service['price_type'] == 'percent' ? true : false;                     
                    
                    $sr_block .= '<div class="block_service">
                    <div class="block_service_title">
                    <label>
                      <input type="checkbox" name="booking_services[]" value="'.$service['ID'].'"/>
                      '.__( 'Add ', BABE_TEXTDOMAIN ).'
                    </label>
                    <h4>'.$service['post_title'].'</h4>
                    </div>
                    <div class="block_service_prices">
                    ';
                    
                    $general_price = $service['prices'][0];
                    
                    $other_prices = $service['prices'];
                    unset($other_prices[0]);
                    $is_other_prices = false;
                    foreach ($other_prices as $test_age => $test_price){
                        $is_other_prices = $test_price !== '' ? true : $is_other_prices; 
                    }
                    
                    $service_ages = array_keys($service['prices']);
                    
                    if (!in_array($before_service_type, array('booking', 'day', 'night'))){
                 
                     foreach($ages as $age_id => $age){
                        $sr_block .= '<span class="service_price_line">';
                        
                        if (!$is_percent){
                          $sr_block .= $is_other_prices ? (isset($other_prices[$age_id]) && $other_prices[$age_id] !== '' ? '<label>'.apply_filters('translate_text', $age['name']).':</label>'.BABE_Currency::get_currency_price($other_prices[$age_id] + round($other_prices[$age_id] * $tax_am, 2)) : '') : '<label>'.apply_filters('translate_text', $age['name']).':</label>'.BABE_Currency::get_currency_price($general_price + round($general_price * $tax_am, 2));
                        } else {
                          $sr_block .= $is_other_prices ? (isset($other_prices[$age_id]) && $other_prices[$age_id] !== ''? '<label>'.apply_filters('translate_text', $age['name']).':</label>'.$other_prices[$age_id].' '.__( '%/booking ', BABE_TEXTDOMAIN ) : '') : '<label>'.apply_filters('translate_text', $age['name']).':</label>'.$general_price.' '.__( '%/booking ', BABE_TEXTDOMAIN );  
                        }
                        
                        $sr_block .= '</span>';
                     }
                     
                     } else {
                        $sr_block .= '<span class="service_price_line">';
                        
                        if (!$is_percent){
                          $sr_block .= BABE_Currency::get_currency_price($general_price + round($general_price * $tax_am, 2));
                        } else {
                          $sr_block .= $general_price.' '.__( '%/booking ', BABE_TEXTDOMAIN );  
                        }
                        
                        $sr_block .= '</span>';
                     }     
                 
                     $sr_block .= '</div>
                     </div>';   
                    
                     $results[] = apply_filters('babe_add_service_block_html', $sr_block, $service, $ages);
                }
                
                if(!empty($results)){
                    
                    $services_header = '<div class="block_services_header_padding"></div>
                    <div class="block_services_header_names">';
                    
                    foreach($ages as $age_id => $age){
                        $services_header .= '<span class="block_service_age_name">
                          '.apply_filters('translate_text', $age['name']).'
                        </span>';
                    }
                    
                    $services_header.= '</div>';
                    
              $hidden_fields = '';
              
              $post_arr = $_GET;
              
              unset($post_arr['action']);
              unset($post_arr['current_action']);
              
              //print_r($post_arr);
              
              foreach($post_arr as $key => $value){
                if ($key != 'booking_guests'){
                  $hidden_fields .= '
                  <input type="hidden" name="'.$key.'" value="'.$value.'">
                  ';
                } else {
                    foreach($value as $guest_id => $guest_num){
                        $hidden_fields .= '
                  <input type="hidden" name="booking_guests['.$guest_id.']" value="'.$guest_num.'">
                  ';
                    }
                }  
              }      
                
                $output .= '
              <form name="add_services" id="add_services" method="post" action="">  
              <div id="block_services">
                <div class="block_services_title"></div>
                <div class="block_services_header">
                '.$services_header.'
                </div>
                '.implode('', $results).'
              </div>
              '.$hidden_fields.'
              <input type="hidden" name="action" value="to_checkout">
              <button class="btn button services_form_submit">'.__('Continue', BABE_TEXTDOMAIN).' <i class="fas fa-caret-right"></i></button>
              </form>';
                 }
                
             }   
        } //// end if !empty($post['services'])    
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Add services to booking_obj page.
     * @param array $post
     * @return string
	 */
    public static function block_services($post){

        $output = '';
        $results = array();
        
        if (!empty($post) && isset($post['services']) && !empty($post['services'])){
            
             $services_arr = BABE_Post_types::get_post_services($post);
             
             if (!empty($services_arr)){
                
                $rules_cat = BABE_Booking_Rules::get_rule_by_obj_id($post['ID']);
                
                $tax_am = isset($rules_cat['category_meta']['categories_add_taxes']) && $rules_cat['category_meta']['categories_add_taxes'] && isset($rules_cat['category_meta']['categories_tax']) ? floatval($rules_cat['category_meta']['categories_tax'])/100 : 0;
        // $tax = 1 + $tax_am;
                
                $ages = BABE_Post_types::get_ages_arr();
                
                $ages = empty($ages) ? array(0 => array('name' => __( 'Price', BABE_TEXTDOMAIN ), 'description' => '')) : $ages;
                
                $i = 0;
                $before_service_type = '';
                
                foreach($services_arr as $service){

                    $sr_block = '';
                    
                    if ($before_service_type != $service['service_type']){
                        $sr_block .= '<div class="block_service">
                        <h4 class="block_service_header">
                        '.__( 'Prices ', BABE_TEXTDOMAIN ).BABE_Post_types::$service_type_names[$service['service_type']].'
                        </h4>
                        </div>';
                        
                        $before_service_type = $service['service_type'];
                    }
                    
                    $is_percent = $before_service_type == 'booking' && $service['price_type'] == 'percent' ? true : false;                     
                    
                    $sr_block .= '<div class="block_service">
                    <div class="block_service_title">
                    <h4>'.$service['post_title'].'</h4>
                    </div>
                    <div class="block_service_prices">
                    ';
                    
                    $general_price = floatval($service['prices'][0]);
                    
                    $other_prices = $service['prices'];
                    
                    unset($other_prices[0]);
                    
                    $is_other_prices = false;
                    
                    if (is_array($other_prices)){
                      foreach ($other_prices as $test_age => $test_price){
                        $is_other_prices = $test_price !== '' ? true : $is_other_prices; 
                      }
                    }  
                    
                    if (!in_array($before_service_type, array('booking', 'day', 'night'))){
                 
                     foreach($ages as $age_id => $age){
                        
                        $sr_block .= '<span class="service_price_line">';
                        
                        if (!$is_percent){
                            
                          $price_value = $is_other_prices ? ( isset($other_prices[$age_id]) && $other_prices[$age_id] !== '' ? floatval($other_prices[$age_id]) : '' ) : $general_price;
                          
                          if ($price_value !== ''){
                            
                             $price_value_html = $price_value == 0 ? __( 'included', BABE_TEXTDOMAIN ) : BABE_Currency::get_currency_price($price_value + round($price_value * $tax_am, 2));
                             
                             $sr_block .= '<label>'.apply_filters('translate_text', $age['name']).':</label>'.$price_value_html.'</span>';
                            
                          }
                          
                        } else {
                          $sr_block .= $is_other_prices ? (isset($other_prices[$age_id]) && $other_prices[$age_id] !== ''? '<label>'.apply_filters('translate_text', $age['name']).':</label>'.$other_prices[$age_id].' '.__( '%/booking ', BABE_TEXTDOMAIN ) : '') : '<label>'.apply_filters('translate_text', $age['name']).':</label>'.$general_price.' '.__( '%/booking ', BABE_TEXTDOMAIN );  
                        }
                        
                        $sr_block .= '</span>';
                     }
                     
                     } else {
                        $sr_block .= '<span class="service_price_line">';
                        
                        if (!$is_percent){
                            
                          $price_value_html = $general_price == 0 ? __( 'included', BABE_TEXTDOMAIN ) : BABE_Currency::get_currency_price($general_price + round($general_price * $tax_am, 2));
                            
                          $sr_block .= $price_value_html;
                          
                        } else {
                          $sr_block .= $general_price.' '.__( '%/booking ', BABE_TEXTDOMAIN );  
                        }
                        
                        $sr_block .= '</span>';
                     }     
                 
                     $sr_block .= '</div>
                     </div>';   
                    
                     $results[] = apply_filters('babe_post_service_block_html', $sr_block, $service, $ages);
                }
                
                if(!empty($results)){
                    
                    $services_header = '<div class="block_services_header_padding"></div>
                    <div class="block_services_header_names">';
                    
                    foreach($ages as $age_id => $age){
                        $services_header .= '<span class="block_service_age_name">
                          '.apply_filters('translate_text', $age['name']).'
                        </span>';
                    }
                    
                    $services_header.= '</div>';
                
                $output .= '<div id="block_services">
                <div class="block_services_title"></div>
                <div class="block_services_header">
                '.$services_header.'
                </div>
                '.implode('', $results).'
              </div>';
                 }
                
             }   
        } //// end if !empty($post['services'])    
        
        return $output; 
    }                    
    
////////////////////////////
    /**
	 * Add meeting points to booking_obj page.
     * @param array $post
     * @return string
	 */
    public static function block_meeting_points($post){

        $output = '';
        $results = array();
        
       // $output .= print_r( $post, 1);
        
        if (!empty($post) && isset($post['meeting_points']) && isset($post['meeting_place']) && $post['meeting_place'] == 'point'){
            
        if (isset($post['address']['address']) && isset($post['address']['latitude']) && isset($post['address']['longitude'])){
            $address = apply_filters('translate_text', $post['address']['address']);
            $lat = $post['address']['latitude'];
            $lng = $post['address']['longitude'];
        } else {
            $address = '';
            $lat = '';
            $lng = '';
        }  
            
        $output .= '<div id="block_meeting_points">
            <h3>'.__('Find closest meeting point', BABE_TEXTDOMAIN).'</h3>
            <div class="meeting-points">
              <div class="meeting_points_search">
              <input class="address-autocomplete" name="autocomplete" placeholder="'.__( 'Enter your address', BABE_TEXTDOMAIN ).'" type="text" />
              <button class="btn button find_points">'.__('Search', BABE_TEXTDOMAIN).'</button>
              <div id="travel_mode_panel">
              <label for="travel_mode">'.__('Mode of Travel: ', BABE_TEXTDOMAIN).'</label>
                <select id="travel_mode" name="travel_mode">
                <option value="WALKING">'.__('Walking', BABE_TEXTDOMAIN).'</option>
                <option value="DRIVING">'.__('Driving', BABE_TEXTDOMAIN).'</option>
                <option value="BICYCLING">'.__('Bicycling', BABE_TEXTDOMAIN).'</option>
                </select>
               </div>
               
               </div>
               
              <div id="meeting_points_result"></div>
            </div>
            <div id="google_map_meeting_points" data-obj-id="'.$post['ID'].'" data-lat="'.$lat.'" data-lng="'.$lng.'" data-address="'.$address.'">
            </div>     
        </div>';    
            
        $meeting_points = BABE_Post_types::get_post_meeting_points($post);
           
           if (!empty($meeting_points)){
              foreach($meeting_points as $point_id => $meeting_point){      
                $results[] = '<div class="meeting_point_default" data-point-id="'.$point_id.'">
                <div class="meeting_point_description">
                <h4>'.implode(', ', $meeting_point['times']).' - <a href="'.$meeting_point['permalink'].'" target="_blank">'.$meeting_point['address'].'</a></h4>
                '.$meeting_point['description'].'
                </div>
              </div>';
              }
              
              $output .= '<div id="block_meeting_points_default">
              '.implode('', $results).'
              </div>';
            
           } //// end if !empty($meeting_points)
        
        }
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Add address map to booking_obj post.
     * @param array $post
     * @return string
	 */
    public static function block_address_map($post){

        $output = '';
        
        if (!empty($post) && isset($post['address']['address']) && isset($post['address']['latitude']) && isset($post['address']['longitude'])){
        
        $address = apply_filters('translate_text', $post['address']['address']);
        $lat = $post['address']['latitude'];
        $lng = $post['address']['longitude'];
        
        $output .= '<div id="block_address_map">
            <div id="google_map_address" data-obj-id="'.$post['ID'].'" data-lat="'.$lat.'" data-lng="'.$lng.'" data-address="'.$address.'">
            </div>     
        </div>';
        }
        
        return $output; 
    }
    
////////////////////////////
    /**
	 * Add address map with direction to booking_obj post.
     * @param array $post
     * @return string
	 */
    public static function block_address_map_with_direction($post){

        $output = '';
        
        if (!empty($post) && isset($post['address']['address']) && isset($post['address']['latitude']) && isset($post['address']['longitude'])){
        
        $address = apply_filters('translate_text', $post['address']['address']);
        $lat = $post['address']['latitude'];
        $lng = $post['address']['longitude'];
        
        $output .= '<div id="block_address_map_with_direction">
             <h3>'.__('Find a route from your location', BABE_TEXTDOMAIN).'</h3>              
              
              <input class="address-autocomplete" name="autocomplete" placeholder="'.__( 'Enter your address', BABE_TEXTDOMAIN ).'" type="text" />
              
              <div id="travel_mode_panel">
                <label for="travel_mode">'.__('Mode of Travel: ', BABE_TEXTDOMAIN).'</label>
                <select id="travel_mode" name="travel_mode">
                <option value="WALKING">'.__('Walking', BABE_TEXTDOMAIN).'</option>
                <option value="DRIVING">'.__('Driving', BABE_TEXTDOMAIN).'</option>
                <option value="BICYCLING">'.__('Bicycling', BABE_TEXTDOMAIN).'</option>
                </select>
               </div>
               
            <div id="google_map_address_with_direction" data-obj-id="'.$post['ID'].'" data-lat="'.$lat.'" data-lng="'.$lng.'" data-address="'.$address.'">
            </div>    
        </div>
        
        ';
        }
        
        return $output; 
    }    

////////////////////////////
    
}

BABE_html::init();
